package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import jp.gr.java_conf.abagames.util.*;
import gl4java.*;

/**
  Bullet operation
  */
public class Bullet extends LayerdSprite implements IMove {
  static private IShape[] shapes = new IShape[5];

  static {
    shapes[0] = new Arrow();
    shapes[1] = new Square();
    shapes[2] = new Dia();
    shapes[3] = new Round();
    shapes[4] = new Bar();
  }

  private boolean existf;
  private float mx, my;
  private int elCnt;

  public Bullet(GLFunc gl) {
    super(gl);
    red = 0.2f; green = 1.0f; blue = 0.2f;
    existf = false;
  }

  final public void start(float x, float y, float layer, float deg, float speed,
   int shapeIdx, int elCnt) {
    this.x = x; this.y = y; this.layer = layer; this.deg = deg;
    mx =  SCTable.sin[(int)deg]*speed;
    my = -SCTable.cos[(int)deg]*speed;
    this.elCnt = elCnt;
    shape = shapes[shapeIdx];
    existf = true;
  }

  public void clear() {
    existf = false;
  }

  final public void disappear() {
    existf = false;
  }

  final public void disappearEngLine() {
    elCnt--;
  }

  final public void move() {
    x += mx;
    y += my;
    if ( elCnt<=0 && (x>Comraid.frmWidth || x<-Comraid.frmWidth
     || y>Comraid.frmHeight || y<-Comraid.frmHeight) ) existf = false;
  }

  final public boolean exists() {
    return existf;
  }
}

