package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.util.gl4j.*;

/**
  Craft Engage data
  */
public abstract class CraftGenerator {
  public IShape shape;

  abstract public void makeManeuver(MnvData[] mnvData);
  abstract public void makeBulletData(BltData[] bltData);
  abstract public void makeCollisionData(ClsData[] clsData);
  abstract public void setCraftProperties(EngData ed);

  private float lyrOfs;
  protected EngData ed;

  public final void setEngData(EngData ed) {
    lyrOfs = ed.lyrOfs;
    this.ed = ed;
    setCraftProperties(ed);
  }

  protected final void setManueuverData(MnvData[] mnvData, float[][] mdSeed) {
    for ( int i=mdSeed.length-1 ; i>=0 ; i-- ) {
      mnvData[i].x = mdSeed[i][0]; mnvData[i].y = mdSeed[i][1];
      mnvData[i].layer = mdSeed[i][2]+lyrOfs; mnvData[i].deg = mdSeed[i][3];
      mnvData[i].time = (int)mdSeed[i][4];
    }
    mnvData[mdSeed.length].time = -1;
  }

  protected final void setBulletData(BltData[] bltData, float[][] bdSeed) {
    for ( int i=bdSeed.length-1 ; i>=0 ; i-- ) {
      bltData[i].type = (int)bdSeed[i][0];
      bltData[i].ofsDeg = bdSeed[i][1]; bltData[i].speed = bdSeed[i][2];
      bltData[i].ofsX = bdSeed[i][3]; bltData[i].ofsY = bdSeed[i][4];
      bltData[i].shapeIdx = (int)bdSeed[i][5];
      bltData[i].engLine = (int)bdSeed[i][6]; bltData[i].time = (int)bdSeed[i][7];
    }
    bltData[bdSeed.length].time = 99999;
  }

  final private float CLSBND = 1.2f;

  protected final void setCollisionData(ClsData[] clsData, float[][] cdSeed) {
    for ( int i=cdSeed.length-1 ; i>=0 ; i-- ) {
      clsData[i].x = cdSeed[i][0]; clsData[i].y = cdSeed[i][1];
      clsData[i].width = cdSeed[i][2]+CLSBND;
      clsData[i].height = cdSeed[i][3]+CLSBND;
    }
    clsData[cdSeed.length].width = -1;
  }
}

