package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import jp.gr.java_conf.abagames.util.*;
import gl4java.*;
import java.util.Random;

/**
  Laser operation
  */
public class Laser extends LayerdSprite implements IMove {
  static private IShape shape = new LaserShape();

  private boolean existf;
  public boolean isValid;
  private Battery battery;

  public Laser(GLFunc gl, Battery battery) {
    super(shape, gl);
    this.battery = battery;
    existf = false;
  }

  private float SPEED = 1.2f;

  final public void start(float ofy) {
    x = battery.x-battery.mx; y = battery.y+ofy-battery.my; layer = 1;
    xScl = battery.lsrScl;
    red = 0.2f; green = 0.8f; blue = 0.8f;
    existf = true;
    isValid = true;
    dapCnt = -1;
  }

  public void clear() {
    existf = false;
  }

  private int dapCnt;

  final public void hit() {
    isValid = false;
    dapCnt = 4;
    red = 0;
  }

  final public void move() {
    y += SPEED;
    x += battery.mx; y += battery.my;
    if ( y>Comraid.frmHeight ) {
      existf = false; isValid = false;
    }
    if ( dapCnt >= 0 ) {
      dapCnt--; green -= 0.1f; blue -= 0.1f;
      xScl *= 0.8f;
      if ( dapCnt == 0 ) existf = false;
    } else {
      xScl = battery.lsrScl;
      if ( xScl == 0 ) {
        existf = false; isValid = false;
      }
    }
  }

  final public boolean exists() {
    return existf;
  }
}
