package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.util.gl4j.*;
import jp.gr.java_conf.abagames.util.*;
import gl4java.*;
import java.util.Random;

/**
  Sprites on Layerd Frame
  */
public class LayerdSprite {
  static private int lsDeg = 0, lsCnt = 0;
  static private int skType = -1, skWidth = 5, skMd = 2;
  static private Random rnd = new Random();

  static public void startShake() {
    lsDeg = 360; lsCnt = 0;
    skType = -1;
  }

  static public void shake(int bssTime) {
    lsDeg += skMd;
    lsCnt--;
    if ( lsDeg >= 360 ) {
      lsDeg -= 360;
      if ( lsCnt <= 0 ) {
        skType = (rnd.nextInt()&3);
        if ( bssTime < 0 ) {
          skWidth = (rnd.nextInt()&7)+3;
        } else {
          skWidth = (rnd.nextInt()&31)+3;
        }
        lsCnt = (rnd.nextInt()&511)+120;
      }
    }
  }

  static public void stopBossShake() {
    lsDeg = 360; lsCnt = 0;
    shake(-1);
  }

  private GLFunc gl;
  public IShape shape;
  public float x, y, layer, deg;
  public float dstDeg, xScl, yScl;
  public float red, green, blue;

  public LayerdSprite(IShape shape, GLFunc gl) {
    this(gl);
    this.shape = shape;
  }

  public LayerdSprite(GLFunc gl) {
    this.gl = gl;
    xScl = yScl = 1.0f;
  }

  public final void draw() {
    gl.glPushMatrix();
    switch ( skType ) {
      case 0:
        gl.glRotatef((layer-1)*SCTable.sin[lsDeg]*skWidth,
         1, SCTable.cos[lsDeg], 1);
        break;
      case 1:
        gl.glRotatef((layer-1)*SCTable.sin[lsDeg]*skWidth,
         0, 0, 1);
        break;
      case 2:
        gl.glRotatef((layer-1)*SCTable.sin[lsDeg]*skWidth,
         1, 0, 0);
        break;
      case 3:
        gl.glRotatef((layer-1)*SCTable.sin[lsDeg]*skWidth,
         0, 1, SCTable.cos[lsDeg]);
        break;
    }
    if ( layer == 0 ) {
      gl.glTranslatef(x, Comraid.frmHeight, -y-Comraid.frmHeight);
      gl.glRotatef(270, 1, 0, 0);
    } else {
      gl.glTranslatef(x, y, layer*-5f);
    }
    gl.glRotatef(deg, 0, 0, 1);
    if ( dstDeg != -1 ) {
      gl.glRotatef(dstDeg, 1, 1, 0);
    }
    if ( xScl != 1 || yScl != 1 ) {
      gl.glScalef(xScl, yScl, 1.0f);
    }
    if ( layer == 1 ) {
      gl.glColor3f(red, green, blue);
    } else if ( layer == 0 ) {
      gl.glColor3f(red*0.8f, green*0.8f, blue*0.8f);
    } else if ( layer < 1 ) {
      gl.glColor3f(red*layer, green*layer, blue*layer);
    } else if ( layer < 2 ) {
      gl.glColor3f(red*(3-layer)*0.3f, green*(3-layer)*0.3f, blue*(3-layer)*0.3f);
    } else {
      gl.glColor3f(red*0.3f, green*0.3f, blue*0.3f);
    }
    shape.draw(gl);
    gl.glPopMatrix();
  }
}

