package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.*;
import gl4java.*;

/**
  Letters Sprite
  */
public class Letters extends LayerdSprite implements IMove {
  static public LettersShape ls = new LettersShape();

  public boolean existf;
  public int time;

  public Letters(GLFunc gl) {
    super(gl);
    red = 0.8f; green = 1.0f; blue = 0.8f;
    shape = new ConnectedShape();
    existf = false;
  }

  final private float LTOFS = 1.8f;

  final public Letters start(String text, float x, float y, float layer,
   float size, int time) {
    set(x, y, size);
    add(text);
    this.layer = layer;
    this.time = time;
    existf = true;
    return this;
  }

  public void clear() {
    existf = false;
  }

  private int length;
  private float cx;

  public final void set() {
    ((ConnectedShape)shape).set(LTOFS);
    length = 0;
  }

  public final void set(float x, float y, float size) {
    set();
    cx = x; this.y = y;
    this.xScl = this.yScl = size;
  }

  public final void add(String text) {
    for ( int i=0 ; i<text.length() ; i++ ) {
      char c = text.charAt(i);
      add(c);
    }
  }

  private int[] nFgrs = new int[16];

  public final void add(int nmb) {
    if ( nmb == 0 ) {
      add('0');
    }
    int lgt = 0;
    for ( ; nmb > 0 ; lgt++, nmb/=10 ) {
      nFgrs[lgt] = nmb%10;
    }
    for ( int i=lgt-1 ; i>=0 ; i-- ) {
      ((ConnectedShape)shape).addShape(ls.shapes[nFgrs[i]]);
    }
    length += lgt;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  public final void add(char c) {
    if ( c == ' ' ) {
      ((ConnectedShape)shape).skipChar();
    } else if ( c == '.' ) {
      ((ConnectedShape)shape).addShape(ls.shapes[10+26]);
    } else if ( c == '_' ) {
      ((ConnectedShape)shape).addShape(ls.shapes[10+26+1]);
    } else if ( c >= 'A' ) {
      c -= 'A'-10;
      ((ConnectedShape)shape).addShape(ls.shapes[c]);
    } else {
      c -= '0';
      ((ConnectedShape)shape).addShape(ls.shapes[c]);
    }
    length++;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  public final void setSize(float size) {
    xScl = yScl = size;
    x = cx - (length-1)*LTOFS*xScl/2;
  }

  final public void move() {
    time--;
    if ( time < 0 ) existf = false;
  }

  final public boolean exists() {
    return existf;
  }
}
