package jp.gr.java_conf.abagames.comraid;

import java.io.*;
import java.awt.Rectangle;

/**
  Save Data Manager
  */
public class SaveDataManager {
  private SaveData saveData;

  private void setDefaultData() {
    saveData = new SaveData();
    saveData.sceneUIRect = new Rectangle(0, 0, 640, 480);
    saveData.creditMax = 3;
    saveData.shwLyrNmb = 4;
    saveData.frameSkip = 0;
    saveData.stgNmb = 1;
    saveData.joystickf = false;
    saveData.bgmf = true;
    saveData.sef = true;
    for ( int i=0 ; i<10 ; i++ ) {
      saveData.rnkScores[i] = 100000-i*10000;
      saveData.rnkNames[i][0] = 'C';
      saveData.rnkNames[i][1] = 'R';
      saveData.rnkNames[i][2] = 'D';
    }
    for ( int i=0 ; i<saveData.stgScores.length ; i++ ) {
      saveData.stgScores[i] = 0;
      for ( int j=0 ; j<saveData.replays[i].length ; j++ ) {
        saveData.replays[i][j] = 1;
      }
    }
  }

  private byte[] serializeObject(Object obj) throws IOException {
    byte[] bytes;

    ByteArrayOutputStream bo = new ByteArrayOutputStream();
    ObjectOutputStream oo = new ObjectOutputStream(bo);
    oo.writeObject(obj);
    oo.flush();
    bytes = bo.toByteArray();
    oo.close();
    bo.close();
    return bytes;
  }

  private Object deserializeObject(byte[] bytes) throws Exception {
    Object obj;

    ByteArrayInputStream bi = new ByteArrayInputStream(bytes);
    ObjectInputStream oi = new ObjectInputStream(bi);
    try {
      obj = oi.readObject();
    } finally {
      oi.close();
      bi.close();
    }
    return obj;
  }

  public SaveData getSaveData() {
    return saveData;
  }

  final private String saveFilename = "comraid.dat";

  public void load() {
    try {
      File fl = new File(saveFilename);
      byte[] b = new byte[(int)fl.length()];
      FileInputStream fis = new FileInputStream(fl);
      fis.read(b);
      saveData = (SaveData)deserializeObject(b);
      fis.close();
    } catch ( Exception e ) {
      setDefaultData();
    }
  }

  public void save() {
    try {
      byte[] b = serializeObject(saveData);
      File fl = new File(saveFilename);
      FileOutputStream fos = new FileOutputStream(fl);
      fos.write(b);
      fos.close();
    } catch ( Exception e ) {}
  }
}
