package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;
import jp.gr.java_conf.abagames.util.*;
import gl4java.*;
import java.util.Random;

/**
  Shot operation
  */
public class Shot extends LayerdSprite implements IMove {
  static private Random rnd = new Random();
  static private IShape shapes[] = new IShape[3];

  static final public int CENTER = 2;
  static final public int LEFT = 1;
  static final public int RIGHT = 0;


  static {
    shapes[CENTER] = new ShotShape();
    shapes[LEFT] = new ShotShape();
    shapes[RIGHT] = new ShotShape();
  }

  private boolean existf;
  private float mx, my;
  public boolean isValid;

  public Shot(GLFunc gl) {
    super(gl);
    existf = false;
  }

  private float SPEED = 1.2f;

  final public void start(int sp, float x, float y) {
    this.x = x; this.y = y; this.layer = 1;
    shape = shapes[sp];
    switch ( sp ) {
      case CENTER:
        mx = 0; my = SPEED; deg = 0;
        break;
      case LEFT:
        mx = -SPEED*0.6f; my = SPEED*0.8f; deg = 30;
        break;
      case RIGHT:
        mx =  SPEED*0.6f; my = SPEED*0.8f; deg = 330;
        break;
    }
    red = 0.2f; green = 0.7f; blue = 0.7f;
    existf = true;
    isValid = true;
    dapCnt = -1;
  }

  public void clear() {
    existf = false;
  }

  private int dapCnt;

  final public void hit() {
    isValid = false;
    dapCnt = 4;
    my = -my*0.7f; mx += (rnd.nextInt()%10)*0.02f;
    red = 0;
  }

  final public void move() {
    x += mx;
    y += my;
    if ( x>Comraid.frmWidth || x<-Comraid.frmWidth
     || y>Comraid.frmHeight ) {
      existf = false; isValid = false;
    }
    if ( dapCnt >= 0 ) {
      dapCnt--; green -= 0.1f; blue -= 0.1f;
      if ( dapCnt == 0 ) existf = false;
    }
  }

  final public boolean exists() {
    return existf;
  }
}

