package jp.gr.java_conf.abagames.comraid;

/**
  Stage Enemy Engage Data
  */
public abstract class StageData {
  final private int ARGNMB = 4, BSSMVNMB = 8, BSSMDNMB = 4;

  final private int ENGDATANMB = 256;

  public EngData[] engData;

  private int idx;

  public StageData() {
    engData = new EngData[ENGDATANMB];
    idx = 0;
  }

  private void sortLayer(EngData[] engQue, int idx) {
    for ( int i=1 ; i<idx ; i++ ) {
      for ( int j=i-1 ; j>=0 ; j-- ) {
        if ( engQue[j].lyrOfs > engQue[j+1].lyrOfs ) {
          EngData teq = engQue[j];
          engQue[j] = engQue[j+1];
          engQue[j+1] = teq;
        } else {
          break;
        }
      }
    }
  }

  protected void endEngageData() {
    engData[idx] = new EngData();
    engData[idx].lyrOfs = 99999;
    sortLayer(engData, idx);
  }

  protected void addEngageData(float[][] edSeed, CraftGenerator[] cgs) {
    for ( int i=0 ; i<edSeed.length ; i++, idx++ ) {
      engData[idx] = new EngData();
      engData[idx].cg = cgs[(int)edSeed[i][0]];
      engData[idx].args = new float[ARGNMB];
      for ( int j=0 ; j<ARGNMB ; j++ ) {
        engData[idx].args[j] = edSeed[i][j+1];
      }
      engData[idx].lyrOfs = (int)edSeed[i][ARGNMB+1];
      engData[idx].stScr = (int)edSeed[i][ARGNMB+2];
      engData[idx].decScr = (int)edSeed[i][ARGNMB+3];
      engData[idx].dattID = (int)edSeed[i][ARGNMB+4];
      engData[idx].scrTimes = 1;
      engData[idx].time = (int)edSeed[i][ARGNMB+5];
      engData[idx].shield = -1;

      engData[idx].bssID = 0;
      engData[idx].delaydApp = false;
    }
  }

  protected void addBossEngageData(float[][] edSeed, CraftGenerator[] cgs) {
    for ( int i=0 ; i<edSeed.length ; i++, idx++ ) {
      engData[idx] = new EngData();
      engData[idx].cg = cgs[(int)edSeed[i][0]];
      engData[idx].args = new float[ARGNMB];
      for ( int j=0 ; j<ARGNMB ; j++ ) {
        engData[idx].args[j] = edSeed[i][j+1];
      }
      engData[idx].lyrOfs = (int)edSeed[i][ARGNMB+1];
      engData[idx].stScr = (int)edSeed[i][ARGNMB+2];
      engData[idx].decScr = (int)edSeed[i][ARGNMB+3];
      engData[idx].dattID = (int)edSeed[i][ARGNMB+4];
      engData[idx].scrTimes = 1;
      engData[idx].time = (int)edSeed[i][ARGNMB+5];
      engData[idx].shield = -1;

      engData[idx].bssID = (int)edSeed[i][ARGNMB+6];
      if ( (int)edSeed[i][ARGNMB+7] == 1 ) {
        engData[idx].delaydApp = true;
      } else {
        engData[idx].delaydApp = false;
      }
      engData[idx].mvBssID = new int[BSSMVNMB];
      for ( int j=0 ; j<BSSMVNMB ; j++ ) {
        engData[idx].mvBssID[j] = (int)edSeed[i][ARGNMB+8+j];
      }
      engData[idx].mdBssID = new int[BSSMDNMB];
      for ( int j=0 ; j<BSSMDNMB ; j++ ) {
        engData[idx].mdBssID[j] = (int)edSeed[i][ARGNMB+8+BSSMVNMB+j];
      }
    }
  }

  public abstract int getBossEngTime();
  public abstract int getStageEndTime();
  public abstract String getMessage();
  public abstract String getBgmFileName();
}
