package jp.gr.java_conf.abagames.comraid;

import jp.gr.java_conf.abagames.comraid.stages.*;

/**
  Stage Enemy Engage Manager
  */
public class StageManager {

  private int stgEngIdx;
  private EngData[] stgEng;
  private EngData endEng;

  public StageData makeStageData(int stage) {
    stgEngIdx = 0;
    engIdx = addEngIdx = 0;

    StageData stgData = null;
    switch ( stage ) {
      case 1:
        stgData = new Stage1();
        break;
      case 2:
        stgData = new Stage2();
        break;
      case 3:
        stgData = new Stage3();
        break;
      case 4:
        stgData = new Stage4();
        break;
      case 5:
        stgData = new Stage5();
        break;
      case 6:
        stgData = new Stage6();
        break;
    }
    stgEng = stgData.engData;
    return stgData;
  }

  private EngData[][] engQues = new EngData[2][256];
  private int engIdx, addEngIdx, queNmb = 0, addQueNmb = 1;

  private void sortTime(EngData[] engQue, int idx) {
    for ( int i=1 ; i<idx ; i++ ) {
      for ( int j=i-1 ; j>=0 ; j-- ) {
        if ( engQue[j].time > engQue[j+1].time ) {
          EngData teq = engQue[j];
          engQue[j] = engQue[j+1];
          engQue[j+1] = teq;
        } else {
          break;
        }
      }
    }
  }

  public final void makeEngQue(int layer, int shwLyrNmb) {
    queNmb ^= 1; addQueNmb ^= 1;
    EngData[] engQue = engQues[queNmb];
    for ( ; ; addEngIdx++, stgEngIdx++ ) {
      EngData ed = stgEng[stgEngIdx];
      if ( ed.lyrOfs > layer+shwLyrNmb ) break;
      engQue[addEngIdx] = ed;
      engQue[addEngIdx].lyrOfs -= layer;
    }
    engQue[addEngIdx] = endEng;
    if ( addEngIdx > 0 ) {
      sortTime(engQue, addEngIdx);
    }
    addEngIdx = engIdx = 0;

    nextEngTime = 0;
  }

  public final void addEngage(EngData ed) {
    ed.lyrOfs--;
    engQues[addQueNmb][addEngIdx] = ed;
    addEngIdx++;
  }

  public int nextEngTime;

  public final void addCrafts(int time) {
    for ( ; ; engIdx++ ) {
      EngData ed = engQues[queNmb][engIdx];
      if ( ed.time > time ) {
        nextEngTime = ed.time;
        break;
      }
      comraid.addCraft(ed);
    }
  }

  private Comraid comraid;

  public StageManager(Comraid comraid) {
    this.comraid = comraid;
    for ( int i=0 ; i<engQues[0].length ; i++ ) {
      engQues[0][i] = new EngData();
      engQues[1][i] = new EngData();
    }
    endEng = new EngData();
    endEng.time = 99999;
  }
}