package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Blt1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 3.5f, 1.5f, 0.5f, 0},
    {-1.0f, 0, 6f, 0.5f, 90}, {1.0f, 0, 6f, 0.5f, 90},
    {0, -3.5f, 1.5f, 0.5f, 0},
    {-1.2f, -3.7f, 0.6f, 0.3f, 45}, {1.2f, -3.7f, 0.6f, 0.3f, 315},
  };
  public Blt1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 5, 0.2f, -6, 0},
    {0, 5, 1, -6, 60}, {0, 5, 1, -6, 240},
    {0, 5, 2, -6, 300},
    {0, 5, 2, -6, 480},
    {0, 5, 2.8f, -6, 540},

    {0, 0, 0, 0, -1},
    {0, 5, 2, -6, 0},
    {0, 5, 2, -6, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[5][0] = ed.args[0]*2;
    mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = mdSeed[4][0]
     = mdSeed[7][0] = mdSeed[8][0]
     = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[9+10+16+15+16+16][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<3 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = -20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = ed.args[1];
      bdSeed[idx][7] = i*60+60;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = ed.args[1];
      bdSeed[idx][7] = i*60+60;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+60;
      idx++;
    }
    for ( int i=0 ; i<5 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = -1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*10+300;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*10+305;
      idx++;
    }
    for ( int i=0 ; i<8 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = -1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+600;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+630;
      idx++;
    }
    for ( int i=0 ; i<5 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = -20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = ed.args[1];
      bdSeed[idx][7] = i*100+1200;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = ed.args[1];
      bdSeed[idx][7] = i*100+1200;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = -3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*100+1200;
      idx++;
    }
    for ( int i=0 ; i<8 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = -1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+1800;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+1830;
      idx++;
    }
    for ( int i=0 ; i<8 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = -1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+2400;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 1.0f; bdSeed[idx][4] = 3.5f;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*60+2430;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.0f},
    {0, -2.0f, 1.0f, 1.0f},
    {0,  2.0f, 1.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 10000;
    if ( ed.shield == -1 ) ed.shield = 700;
  }
}
