package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class BltM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 3.5f, 6.0f, 1.6f, 0}, {0, -3.5f, 6.0f, 1.6f, 0},
    {-3.5f, 0, 6.0f, 1.6f, 90}, {3.5f, 0, 6.0f, 1.6f, 90}
  };
  public BltM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 9, 10f, -2, 0}, {0, 9, 1f, -2, 60},
    //{2, 8, 1f, -2, 180}, {-2, 8, 1f, -2, 300}, {0, 9, 1f, 0, 360},
    {0, 8, 1f, -2, 240}, {0, 9, 1f, -2, 360},
    {60, 0, -99999, 0, 360},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[100+60][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<10 ; i++ ) {
      for ( int j=0 ; j<10 ; j++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = (j*20+90+180)%360;
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 2;
        if ( j==9 || ((i%2)==0 && j==3) || ((i%2)==1 && j==5) ) {
          bdSeed[idx][6] = -1;
        } else {
          bdSeed[idx][6] = 1;
        }
        bdSeed[idx][7] = i*50+100;
        idx++;
      }
    }
    for ( int i=0 ; i<30 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.1f+i*0.015f;
      bdSeed[idx][3] = -1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = i*17+1200+100;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.1f+i*0.015f;
      bdSeed[idx][3] = 1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*17+1200+100;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 3.0f, 3.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 50000;
    if ( ed.shield == -1 ) ed.shield = 700;
  }
}
