package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class BltP extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 2.0f, 3.0f, 0.6f, 0}, {0, -2.0f, 3.0f, 0.6f, 0},
    {-2.0f, 0, 3.0f, 0.6f, 90}, {2.0f, 0, 3.0f, 0.6f, 90}
  };
  public BltP() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 6, 10f, 0, 0},
    {0, 6, 10f, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[24+30][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<24 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = ((i%2)*2-1)*1.5f;
      bdSeed[idx][4] = -1.5f;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*20+600+100;
      idx++;
    }
    for ( int i=0 ; i<10 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = -10;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = -1.5f;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*30+1800+100;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = -1.5f;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*30+1800+100;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 10;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = -1.5f;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*30+1800+100;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
