package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class BltP2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 1.0f, 2.0f, 0.6f, 0}, {0, -1.0f, 2.0f, 0.6f, 0},
    {-1.0f, 0, 2.0f, 0.6f, 90}, {1.0f, 0, 2.0f, 0.6f, 90}
  };
  public BltP2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 8, 10f, 0, 0},
    {0, 8, 10f, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[1+3+1][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 99999;
    idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = -20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 40;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 40;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 40;
      idx++;
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 40;
    idx++;
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
