package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class BshM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 2.0f, 1.0f, 0},
    {-1.0f, 0, 2.0f, 1.0f, 135}, {1.0f, 0, 2.0f, 1.0f, 45},
    {0, 2, 0, 1.0f, 0},
  };
  public BshM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {-15, 0, 1.8f, 0, 0},
    {0, 8, 1, 0, 200},
    {-4, 4, 1, 0, 300},
    {4, 4, 1, 0, 500},
    {0, 8, 1, -4, 600},
    {0, 9, 1, -4, 650},
    {0, 9, 1, -0.001f, 1150},
    {0, 8, 1, 0, 1200},
    {-4, 4, 1, 0, 1400},
    {4, 4, 1, 0, 1600},
    {0, 8, 1, -4, 1800},
    {0, 9, 1, -4, 1850},
    {0, 9, 1, -0.001f, 2350},
    {0, 8, 1, 0, 2400},
    {0, 9, 1, -4, 2450},
    {0, 9, 1, -0.001f, 2950},
    {0, 8, 1, 0, 3000},
    {0, 10, 1, 0, 3200},
    {0, 6, 1, 0, 3400},
    {0, 8, 1, 0, 3600},
    {-6, 2, 1, 0, 3800},
    {6, 2, 1, 0, 4000},
    {0, 8, 1, 0, 4200},
    {0, 0, 1, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  private float adjustDeg(float d) {
    if ( d >= 0 ) {
      return (d%360);
    } else {
      return (359-(Math.abs(d)%360));
    }
  }
  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[60+600+100+15*9+25*3*2*3+60+540][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    float d = -30;
    for ( int i=0 ; i<30 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d-10);
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 200+i*10;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d+10);
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 200+i*10;
      idx++;
      if ( i < 10 ) d += 6;
      else if ( i < 20 ) d -= 6;
      else d+= 6;
    }
    d = 0;
    for ( int i=0 ; i<100 ; i++ ) {
      for ( int j=0 ; j<3 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d-5);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( (i%3) == 0 ) {
          bdSeed[idx][6] = j;
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = 650+i*4;
        idx++;
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d+5);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 650+i*4;
        idx++;
        switch ( j ) {
          case 0:
          case 2:
            d -= 30; break;
          case 1:
            d += 60; break;
        }
      }
      if ( i < 20 ) d += 0;
      else if ( i < 25 ) d -= 3.5f;
      else if ( i < 35 ) d += 3.5f;
      else if ( i < 45 ) d -= 3.5f;
      else if ( i < 55 ) d += 3.5f;
      else if ( i < 65 ) d -= 3.5f;
      else if ( i < 70 ) d += 3.5f;
    }
    d = -30;
    for ( int i=0 ; i<50 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = adjustDeg(d-10);
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      if ( (i%2)==0 ) {
        bdSeed[idx][6] = 1;
      } else {
        bdSeed[idx][6] = 2;
      }
      bdSeed[idx][7] = 1200+i*10;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = adjustDeg(d+10);
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1200+i*10;
      idx++;
      if ( i < 10 ) d += 6;
      else if ( i < 20 ) d -= 6;
      else if ( i < 30 ) d += 6;
      else if ( i < 40 ) d -= 6;
      else d += 6;
    }
    int c, cc = 0;
    int[] cp = {1, 0, 2, 0, 1};
    for ( int i=0 ; i<30 ; i++ ) {
      if ( (i%2)==0 ) {
        d = -18;
        c = 4;
      } else {
        d = -24;
        c = 5;
      }
      for ( int j=0 ; j<c ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d);
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 1;
        if ( j == c-1 ) {
          bdSeed[idx][6] = -1;
        } else {
          bdSeed[idx][6] = cp[cc];
          cc++; if ( cc > 4 ) cc = 0;
        }
        bdSeed[idx][7] = 1800+i*16;
        idx++;
        d += 12;
      }
    }
    d = 0;
    for ( int i=0 ; i<25 ; i++ ) {
      for ( int j=0 ; j<3 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d-4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( (i%3) == 0 ) {
          bdSeed[idx][6] = j;
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = 2450+i*4;
        idx++;
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d+4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 2450+i*4;
        idx++;
        switch ( j ) {
          case 0:
          case 2:
            d -= 30; break;
          case 1:
            d += 60; break;
        }
      }
      if ( i < 4 ) d += 0;
      else if ( i < 8 ) d -= 3.8f;
      else if ( i < 16 ) d += 3.8f;
      else d -= 4f;
    }
    d = -15;
    for ( int i=0 ; i<25 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d-4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( (i%3) == 0 ) {
          bdSeed[idx][6] = 0;
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = 2650+i*4;
        idx++;
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d+4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 2650+i*4;
        idx++;
        switch ( j ) {
          case 0:
            d += 30; break;
          case 1:
            d -= 30; break;
        }
      }
      if ( i < 4 ) d += 0;
      else if ( i < 8 ) d -= 3.8f;
      else if ( i < 16 ) d += 3.8f;
      else d -= 4f;
    }
    d = 0;
    for ( int i=0 ; i<25 ; i++ ) {
      for ( int j=0 ; j<3 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d-4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( (i%3) == 0 ) {
          bdSeed[idx][6] = j;
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = 2850+i*4;
        idx++;
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = adjustDeg(d+4);
        bdSeed[idx][2] = 0.6f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 2850+i*4;
        idx++;
        switch ( j ) {
          case 0:
          case 2:
            d -= 30; break;
          case 1:
            d += 60; break;
        }
      }
      if ( i < 4 ) d += 0;
      else if ( i < 8 ) d -= 3.8f;
      else if ( i < 16 ) d += 3.8f;
      else d -= 4f;
    }
    for ( int i=0 ; i<30 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.1f+i*0.015f;
      bdSeed[idx][3] = -1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = i*17+3000;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.1f+i*0.015f;
      bdSeed[idx][3] = 1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*17+3000;
      idx++;
    }
    for ( int i=0 ; i<540 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = adjustDeg((i*7)%60-30);
      bdSeed[idx][2] = 0.3f+((i*7)%20)*0.01f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i+3600;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 6, 3},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 200000;
    if ( ed.shield == -1 ) ed.shield = 7000;
  }
}
