package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class BshP1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, -2, 12.0f, 0.5f, 0}, {-4, 2, 7.0f, 0.5f, 30}, {4, 2, 7.0f, 0.5f, 150},
    {9, 0, 6.0f, 0.5f, 0}, {5, -2, 2.0f, 0.5f, 90}, {9, -2.5f, 7.0f, 0.5f, 20},
    {-9, 0, 6.0f, 0.5f, 0}, {-5, -2, 2.0f, 0.5f, 90}, {-9, -2.5f, 7.0f, 0.5f, 340},
  };
  public BshP1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {-15, 0, 1.8f, 0, 0},
    {-15, 0, 1.8f, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  private float adjustDeg(float d) {
    if ( d >= 0 ) {
      return (d%360);
    } else {
      return (359-(Math.abs(d)%360));
    }
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[80+128+100][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0, tm;
    float bx, by = -3;
    for ( int i=0 ; i<10 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        bx = j*12-6;
        tm = 200+i*30;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -8;
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 1;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 8;
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -30;
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 30;
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
      }
    }
    for ( int i=0 ; i<16 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        tm = 1200+i*30;
        bx = j*12-6;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -30;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -8;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 8;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 30;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
      }
    }
    for ( int i=0 ; i<25 ; i++ ) {
      tm = 3000+i*20;
      for ( int j=0 ; j<2 ; j++ ) {
        bx = j*12-6;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = adjustDeg((i%5)*9-18);
        bdSeed[idx][2] = 0.2f+(idx%3)*0.1f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 1;
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = adjustDeg((i%5)*9-18);
        bdSeed[idx][2] = 0.2f+(idx%3)*0.1f;
        bdSeed[idx][3] = bx;
        bdSeed[idx][4] = by;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
      }
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
