package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Cat1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.4f, 0.5f, 0.9f, 0.3f, 30}, {0.4f, 0.5f, 0.9f, 0.3f, 330},
    {0, 0.3f, 1.2f, 0.3f, 0},
    {1.1f, 0.2f, 1.1f, 0.2f, 90}, {-1.1f, 0.2f, 1.1f, 0.2f, 90}
  };
  public Cat1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 1.8f, -16, 0}, {0, 0, 1f, -16, 30}, {0, 0, 1f, -16, 90},
    {0, 0, 1.8f, 0, 120}
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[3][0] = ed.args[0]*3;
    mdSeed[0][1] = mdSeed[3][1] = ed.args[1]*3;
    mdSeed[1][0] = mdSeed[2][0] = ed.args[0];
    mdSeed[1][1] = mdSeed[2][1] = ed.args[1];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, -5, 0.2f, -1.0f, 0, 1, 0, 30}, {1, 5, 0.2f, 1.0f, 0, 1, -1, 30}
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 0.6f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 600;
    if ( ed.shield == -1 ) ed.shield = 16;
  }
}
