package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Dff5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 4.0f, 0.5f, 90},
    {-2.0f, -2.0f, 4.0f, 0.5f, 135}, {2.0f, -2.0f, 4.0f, 0.5f, 45},
    {0, 0, 4.0f, 0.5f, 10},
  };
  public Dff5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 1.5f, 0, 0},
    {0, 0, 1, 0, 30},
    {0, 0, 1, 0, 480},
    {0, 0, 1.5f, 180, 510},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[1][0] = mdSeed[2][0] = ed.args[0];
    mdSeed[1][1] = mdSeed[2][1] = ed.args[1];
    mdSeed[1][3] = mdSeed[2][3] = ed.args[2];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[33][8];
  int[] elPtn = {0, 1, 0, 2, 0};
  public void makeBulletData(BltData[] bltData) {
    int idx = 0, ptn = (int)ed.args[3];
    for ( int i=0 ; i<11 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 330;
      bdSeed[idx][2] = 0.15f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = elPtn[ptn%5]; ptn++;
      bdSeed[idx][7] = 30+i*40;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.15f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = elPtn[ptn%5]; ptn += 6;
      bdSeed[idx][7] = 30+i*40;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 30;
      bdSeed[idx][2] = 0.15f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 30+i*40;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.0f, 2.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
