package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Dir1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.6f, 0.5f, 1.0f, 0.4f, 45}, {0.6f, 0.5f, 1.0f, 0.4f, 325},
    {0, -0.5f, 1.8f, 0.5f, 0},
    {-1.0f, -1.2f, 0.8f, 0.3f, 90}, {1.0f, -1.2f, 0.8f, 0.3f, 90}
  };
  public Dir1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -15, 3.5f, 0, 0}, {0, 0, 3.0f, 0, 60}, {0, 3, 3.0f, 0, 120},
    {0, 3, 2.0f, 0, 180}, {0, 6, 2.0f, 0, 240},
    {0, 3, 1.0f, 0, 300}, {0, 6, 1.0f, 0, 360},
    {0, 15, 0.5f, 0, 420},
  };
  public void makeManeuver(MnvData[] mnvData) {
    for ( int i=0 ; i<8 ; i++ ) mdSeed[i][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {2, 0, 0.1f, -1.2f, 0, 1, 0, 60}, {2, 0, 0.1f, 1.2f, 0, 1, -1, 60},
    {2, 0, 0.1f, -1.2f, 0, 1, 0, 180}, {2, 0, 0.1f, 1.2f, 0, 1, -1, 180},
    {2, 0, 0.1f, -1.2f, 0, 1, 0, 300}, {2, 0, 0.1f, 1.2f, 0, 1, -1, 300},
  };
  public void makeBulletData(BltData[] bltData) {
    for ( int i=0 ; i<6 ; i+=2 ) bdSeed[i][6] = ed.args[1];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.1f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 800;
    if ( ed.shield == -1 ) ed.shield = 24;
  }
}
