package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Dir3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.6f, 0.5f, 1.0f, 0.4f, 45}, {0.6f, 0.5f, 1.0f, 0.4f, 325},
    {0, -0.5f, 1.8f, 0.5f, 0},
    {-1.0f, -1.2f, 0.8f, 0.3f, 90}, {1.0f, -1.2f, 0.8f, 0.3f, 90}
  };
  public Dir3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {15, 0, 1.5f, 270, 0}, {10, 0, 1, 270, 60}, {11, 0, 1, 270, 120},
    {15, 0, 0.5f, 90, 180},
  };
  public void makeManeuver(MnvData[] mnvData) {
    if ( ed.args[0] == 0 ) {
      mdSeed[0][1] = mdSeed[3][1] = 15;
      mdSeed[1][1] = 10;
      mdSeed[2][1] = 11;
      mdSeed[0][3] = mdSeed[1][3] = mdSeed[2][3] = 0;
      mdSeed[3][4] = 180;
      for ( int i=0 ; i<4 ; i++ ) mdSeed[i][0] = ed.args[1];
    } else {
      mdSeed[0][0] = mdSeed[3][0] = 15;
      mdSeed[1][0] = 10;
      mdSeed[2][0] = 11;
      mdSeed[0][3] = mdSeed[1][3] = mdSeed[2][3] = 270;
      mdSeed[3][4] = 90;
      for ( int i=0 ; i<4 ; i++ ) mdSeed[i][1] = ed.args[1];
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, 0, 0.2f, -1.2f, 0, 1, 0, 60}, {1, 0, 0.2f, 1.2f, 0, 1, -1, 60},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.1f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 800;
    if ( ed.shield == -1 ) ed.shield = 24;
  }
}
