package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Dup3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0.5f, 1.0f, 0.1f, 0},
    {0, -0.5f, 1.0f, 0.1f, 0},
    {-1.5f, 0, 0.5f, 0.4f, 90},
    {1.5f, 0, 0.5f, 0.4f, 90},
  };
  public Dup3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 0, -5, 0},
    {0, 0, 0, -5, 10},
    {0, 0, 0, -5, 25},
    {0, 0, 0, -5, 35},
    {0, 0, 0, -5, 50},
    {0, 0, 0, -5, 60},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[5][0] = ed.args[0]*3;
    mdSeed[0][1] = mdSeed[5][1] = ed.args[1]*3;
    mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = mdSeed[4][0] = ed.args[0];
    mdSeed[1][1] = mdSeed[2][1] = mdSeed[3][1] = mdSeed[4][1] = ed.args[1];
    switch ( (int)ed.args[2] ) {
      case 0:
        mdSeed[0][2] = 2.5f;
        mdSeed[1][2] = mdSeed[2][2] = 2;
        mdSeed[3][2] = mdSeed[4][2] = 1;
        mdSeed[5][2] = 0.5f;
        break;
      case 1:
        mdSeed[0][2] = 0.5f;
        mdSeed[1][2] = mdSeed[2][2] = 1;
        mdSeed[3][2] = mdSeed[4][2] = 2;
        mdSeed[5][2] = 2.5f;
        break;
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, -6.5f, 0.3f, -2f, 0, 0, 0, 10},
    {0, 6.5f, 0.3f,  2f, 0, 0, -1, 10},
    {0, -6.5f, 0.3f, -2f, 0, 0, 0, 35},
    {0, 6.5f, 0.3f,  2f, 0, 0, -1, 35},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[2][6] = ed.args[3];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.5f, 0.5f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 400;
    if ( ed.shield == -1 ) ed.shield = 8;
  }
}
