package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Evl4 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 4.0f, 0.3f, 0},
    {-1.0f, 0.3f, 1.6f, 0.3f, 20}, {1.0f, 0.3f, 1.6f, 0.3f, 340},
  };
  public Evl4() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 12, 0.9f, -10, 0},
    {0, 10, 1, -10, 15},
    {0, 6, 1, -10, 75},
    {0, 4, 0.4f, -10, 90},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[14][8];

  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    float d;
    for ( int j=0 ; j<2 ; j++ ) {
      for ( int i=0 ; i<7 ; i++ ) {
        bdSeed[idx][0] = 1;
        d = -i*15+45; if ( d < 0 ) d += 360;
        bdSeed[idx][1] = d;
        bdSeed[idx][2] = Math.abs(i-3)*0.06f + 0.2f - j*0.06f;
        bdSeed[idx][3] = i*2f - 6f;
        bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 2;
        if ( i < 6 ) {
          bdSeed[idx][6] = ((i+j*7)%3);
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = 20+20*j;
        idx++;
      }
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.0f, 0.5f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1500;
    if ( ed.shield == -1 ) ed.shield = 50;
  }
}
