package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Fnd3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 1, 0.7f, 0.3f, 0},
    {-0.4f, -0.5f, 2.2f, 0.3f, 70},
    {0.4f, -0.5f, 2.2f, 0.3f, 110},
    {0, -1.5f, 0.3f, 0.3f, 0},
  };
  public Fnd3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -12, 1.5f, 0, 0},
    {0, 0, 1, -3, 30},
    {0, 0, 1, -3, 60},
    {0, 12, 0.5f, 0, 90},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[3][0] = ed.args[0];
    mdSeed[1][1] = mdSeed[2][0] = ed.args[1];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.4f, 0, 0, 0, 0, 30},
    {0, 0, 0.3f, 0, 0, 0, 0, 30},
    {0, 0, 0.2f, 0, 0, 0, -1, 30},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[1][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.6f, 0.8f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 800;
    if ( ed.shield == -1 ) ed.shield = 16;
  }
}
