package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Fng2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 1.2f, 0.8f, 0.2f, 0},
    {-0.6f, 0, 1.6f, 0.3f, 90}, {0.6f, 0, 1.6f, 0.3f, 90},
    {0, -1.2f, 0.8f, 0.2f, 0},
    {1.0f, 0, 0.4f, 0.1f, 0}, {-1.0f, 0, 0.4f, 0.1f, 0},
  };
  public Fng2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -2, 2.5f, -6, 0},
    {0, 0, 2, -6, 20},
    {0, 1, 2, -6, 60},
    {0, 3, 1, -6, 80},
    {0, 4, 1, -6, 120},
    {0, 13, 1, -6, 150}
  };
  public void makeManeuver(MnvData[] mnvData) {
    for ( int i=0 ; i<5 ; i++ ) {
      mdSeed[i][0] = (5-i)*ed.args[0];
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, -20, 0.2f, 0, 0, 2, 0, 20},
    {0, 20, 0.2f, 0, 0, 2, -1, 20},
    {0, -20, 0.2f, 0, 0, 2, 0, 80},
    {0, 20, 0.2f, 0, 0, 2, -1, 80},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[2][6] = ed.args[1];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.6f, 1.2f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 800;
    if ( ed.shield == -1 ) ed.shield = 20;
  }
}
