package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Gcc5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 2.0f, 0.3f, 45}, {0, 0, 2.0f, 0.3f, 135},
    {0, 1.0f, 1.5f, 0.3f, 10}, {0, -1.0f, 1.5f, 0.3f, 10},
  };
  public Gcc5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 5.5f, 0, 0},
    {0, 0, 5, 0, 10},
    {0, 0, 5, 0, 20},
    {0, 0, 4, 0, 30},
    {0, 0, 4, 0, 40},
    {0, 0, 3, 0, 50},
    {0, 0, 3, 0, 60},
    {0, 0, 2, 0, 70},
    {0, 0, 2, 0, 80},
    {0, 0, 1, 0, 90},
    {0, 0, 1, 0, 100},
    {0, 0, 0.5f, 0, 110},
  };
  public void makeManeuver(MnvData[] mnvData) {
    for ( int i=0 ; i<12 ; i++ ) {
      mdSeed[i][0] = ed.args[0];
      mdSeed[i][1] = ed.args[1];
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, -20, 0.2f, 0, 0, 0, -1, 10},
    {0,   0, 0.2f, 0, 0, 0, -1, 10},
    {0,  20, 0.2f, 0, 0, 0, -1, 10},
    {0, -20, 0.2f, 0, 0, 0, -1, 30},
    {0,   0, 0.2f, 0, 0, 0, -1, 30},
    {0,  20, 0.2f, 0, 0, 0, -1, 30},
    {0, -20, 0.2f, 0, 0, 0, -1, 50},
    {0,   0, 0.2f, 0, 0, 0, -1, 50},
    {0,  20, 0.2f, 0, 0, 0, -1, 50},
    {0, -20, 0.2f, 0, 0, 0, -1, 70},
    {0,   0, 0.2f, 0, 0, 0, -1, 70},
    {0,  20, 0.2f, 0, 0, 0, -1, 70},
    {0, -20, 0.2f, 0, 0, 0, -1, 90},
    {0,   0, 0.2f, 0, 0, 0, -1, 90},
    {0,  20, 0.2f, 0, 0, 0, -1, 90},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 500;
    if ( ed.shield == -1 ) ed.shield = 4;
  }
}

