package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Gmpm4 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 0, 1.5f, 0.5f, 60}, {1.0f, 0, 1.5f, 0.5f, 120},
    {0, -1.0f, 0.5f, 0.5f, 0},
  };
  public Gmpm4() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 15, 0.9f, 0, 0},
    {0, 12, 1, -1, 15},
    {0, 9, 1, -1, 30},
    {0, 3, 1, -1, 240},
    {0, -12, 1, -1, 330},
    {0, -15, 0.9f, 0, 345},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0]
     = mdSeed[3][0] = mdSeed[4][0] = mdSeed[5][0] = ed.args[0];
    mdSeed[2][1] = 9-ed.args[1]; mdSeed[2][4] = 30+ed.args[1]*5;
    mdSeed[3][1] = 3-ed.args[1]; mdSeed[3][4] = 240+ed.args[1]*5;
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[16][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<8 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = -7;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = i*30 + 30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 7;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*30 + 30;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.5f, 1.5f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 3000;
    if ( ed.shield == -1 ) ed.shield = 120;
  }
}
