package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Grp1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
   {0, 1.3f, 1.8f, 0.5f, 0},
    {-0.6f, 0, 1.5f, 0.2f, 90}, {0.6f, 0, 1.5f, 0.2f, 90},
    {-0.9f, 0, 1.5f, 0.2f, 45}, {0.9f, 0, 1.5f, 0.2f, 315}
  };
  public Grp1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 10f, 2.5f, 0, 0}, {0, 8f, 2f, 0, 60}, {0, 6f, 2f, 0, 120},
    {0, 4f, 1f, 0, 180}, {0, 2f, 1f, 0, 240}, {0, 0f, 0.5f, 0, 300},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = ed.args[0]*6; mdSeed[1][0] = ed.args[0]*5;
    mdSeed[2][0] = ed.args[0]*4; mdSeed[3][0] = ed.args[0]*3;
    mdSeed[4][0] = ed.args[0]*2; mdSeed[5][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, -20, 0.2f, -1.0f, 0, 0, 0, 60}, {0, -7, 0.2f, -1.0f, 0, 0, -1, 60},
    {0,  20, 0.2f, 1.0f, 0, 0, 0, 60}, {0, 7, 0.2f, 1.0f, 0, 0, -1, 60},
    {0, -20, 0.2f, -1.0f, 0, 0, 0, 180}, {0, -7, 0.2f, -1.0f, 0, 0, -1, 180},
    {0,  20, 0.2f, 1.0f, 0, 0, 0, 180}, {0, 7, 0.2f, 1.0f, 0, 0, -1, 180},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[2][6] = bdSeed[4][6] = bdSeed[6][6] = ed.args[1];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.2f, 1.2f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1000;
    if ( ed.shield == -1 ) ed.shield = 25;
  }
}
