package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Kll5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-2.0f, -4.0f, 4.0f, 0.4f, 150}, {2.0f, -4.0f, 4.0f, 0.4f, 30},
    {-2.0f, -2.0f, 4.0f, 0.4f, 30}, {2.0f, -2.0f, 4.0f, 0.4f, 150},
    {-3.0f, 2.0f, 8.0f, 0.4f, 70}, {-1.0f, 3.0f, 5.0f, 0.4f, 100},
    {3.0f, 2.0f, 8.0f, 0.4f, 110}, {1.0f, 3.0f, 5.0f, 0.4f, 80},
    {-2.5f, -0.5f, 4.0f, 0.4f, 38}, {2.5f, -0.5f, 4.0f, 0.4f, 142},
  };
  public Kll5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 0.5f, 0, 0},
    {0, 7, 1, 0, 90},
    {0, 8, 1, 0, 270},
    {0, 8, 2, 0, 300},
    {0, 6, 2, 0, 480},
    {0, 0, 2.5f, 0, 570},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[208][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<2 ; i++ ) {
      for ( int j=0 ; j<8 ; j++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = i*210 + j*20 + 90;
        idx++;
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 2;
          bdSeed[idx][1] = 348-k*8;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 0;
          if ( k < 5 ) {
            bdSeed[idx][6] = ((j*5+k)%4)-1;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*210 + j*20 + 90;
          idx++;
        }
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 2;
          bdSeed[idx][1] = 12+k*8;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 0;
          if ( k < 5 ) {
            bdSeed[idx][6] = ((j*5+k)%4)-1;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*210 + j*20 + 90;
          idx++;
        }
      }
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 4.0f, 4.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 5000;
    if ( ed.shield == -1 ) ed.shield = 250;
  }
}
