package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Lnt4 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 0, 2.0f, 0.6f, 90}, {1.0f, 0, 2.0f, 0.6f, 90}
  };
  public Lnt4() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 15, 0.9f, -10, 0},
    {0, 12, 1, -10, 15},
    {0, -12, 1, -10, 135},
    {0, -15, 0.9f, -10, 150},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, 0, 0.4f, -1.0f, 0, 1, 0, 20},
    {1, 0, 0.4f,  1.0f, 0, 1, -1, 20},
    {1, 0, 0.3f, -1.0f, 0, 1, 0, 20},
    {1, 0, 0.3f,  1.0f, 0, 1, -1, 20},
    {1, 0, 0.2f, -1.0f, 0, 1, 0, 20},
    {1, 0, 0.2f,  1.0f, 0, 1, -1, 20},
    {1, 0, 0.4f, -1.0f, 0, 1, 0, 60},
    {1, 0, 0.4f,  1.0f, 0, 1, -1, 60},
    {1, 0, 0.3f, -1.0f, 0, 1, 0, 60},
    {1, 0, 0.3f,  1.0f, 0, 1, -1, 60},
    {1, 0, 0.2f, -1.0f, 0, 1, 0, 60},
    {1, 0, 0.2f,  1.0f, 0, 1, -1, 60},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.2f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1000;
    if ( ed.shield == -1 ) ed.shield = 25;
  }
}
