package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Ls1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0.7f, 0.8f, 0.4f, 0},
    {0.8f, 0, 1f, 0.4f, 90}, {-0.8f, 0, 1f, 0.4f, 90},
  };
  public Ls1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 2.8f, 0, 0}, {0, 2, 2f, 0, 15}, {0, 8, 2f, 0, 90},
    {0, 13, 1.5f, 90, 100}, {0, 8, 1f, 180, 110}, {0, 2, 1f, 180, 180},
    {0, 0, 0.2f, 180, 200}
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[6][0] = ed.args[0]*2;
    mdSeed[1][0] = mdSeed[2][0] = mdSeed[4][0] = mdSeed[5][0] = ed.args[0];
    mdSeed[3][0] = ed.args[0]*0.8f;
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.2f, 0, 0, 0, -1, 15},
    {0, 0, 0.2f, 0, 0, 0, -1, 50},
    {0, 0, 0.2f, 0, 0, 0, -1, 110},
    {0, 0, 0.2f, 0, 0, 0, -1, 150},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.8f, 0.8f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 200;
    if ( ed.shield == -1 ) ed.shield = 8;
  }
}
