package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Ls2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, -0.6f, 0.8f, 0.3f, 0},
    {-0.3f, 0.4f, 0.8f, 0.3f, 45},
    {0.3f, 0.4f, 0.8f, 0.3f, 315},
  };
  public Ls2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 13, 1.1f, 180, 0}, {0, 12, 1, -4, 5},
    {0, -2, 1, -4, 40}, {0, -4, 1, -4, 60},
    {0, 12, 1, 0, 90}, {0, 13, 0.9f, 0, 95},
  };
  public void makeManeuver(MnvData[] mnvData) {
    for ( int i=5 ; i>=0 ; i-- ) mdSeed[i][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.2f, 0, 0, 0, -1, 5},
    {0, 0, 0.2f, 0, 0, 0, -1, 35},
    {0, -20, 0.2f, 0, 0, 0, -1, 60},
    {0, 20, 0.2f, 0, 0, 0, -1, 60},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.3f, 0.5f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 300;
    if ( ed.shield == -1 ) ed.shield = 12;
  }
}
