package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Ls3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 1.2f, 0.3f, 0}, {0, 0, 1.2f, 0.3f, 90},
    {-0.3f, -1.1f, 0.5f, 0.3f, 45},
    { 0.3f, -1.1f, 0.5f, 0.3f, 315},
  };
  public Ls3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 1.5f, -5, 0}, {0, 0, 1, -5, 30}, {0, 0, 1, -5, 60},
    {0, 0, 1.5f, -5, 90},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[1][0] = ed.args[0]*2; mdSeed[1][1] = ed.args[1]*2;
    mdSeed[2][0] = ed.args[0]*3; mdSeed[2][1] = ed.args[1]*3;
    mdSeed[3][0] = ed.args[0]*4; mdSeed[3][1] = ed.args[1]*4;
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.2f, 0, 0, 0, -1, 30},
    {0, 0, 0.2f, 0, 0, 0, -1, 60},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.7f, 0.9f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 300;
    if ( ed.shield == -1 ) ed.shield = 10;
  }
}
