package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Mak2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 3.0f, 0.4f, 45}, {0, 0, 3.0f, 0.4f, 315},
    {0, -1.6f, 3.2f, 0.6f, 0},
    {0, 0, 3.2f, 0.6f, 0},
    {0, 1.6f, 3.2f, 0.6f, 0},
  };
  public Mak2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 13, 0.5f, 0, 0},
    {0, 9, 1, 0, 30},
    {0, 9, 1, 0, 150},
    {0, 9, 2, 0, 210},
    {0, 9, 2, 0, 330},
    {0, 9, 3, 0, 390},
    {0, 9, 3, 0, 510},
    {0, 13, 3.5f, 0, 540},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[60][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<3 ; i++ ) {
      for ( int j=0 ; j<4 ; j++ ) {
        for ( int k=0 ; k<5 ; k++ ) {
          bdSeed[idx][0] = 0;
          bdSeed[idx][1] = k*10*((j%2)*2-1);
          bdSeed[idx][2] = 0.4f - k*0.05f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 0;
          if ( k==0 || k==3 ) {
            bdSeed[idx][6] = 0;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = j*20 + i*180 + 30;
          idx++;
        }
      }
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.6f, 1.6f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 5000;
    if ( ed.shield == -1 ) ed.shield = 200;
  }
}
