package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Nce5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, -1.0f, 4.0f, 0.4f, 0}, {0, 1.0f, 4.0f, 0.4f, 0},
    {-2.0f, 0, 1.0f, 0.4f, 90}, {2.0f, 0, 1.0f, 0.4f, 90},
    {-2.5f, -1.5f, 0.4f, 0.4f, 45}, {2.5f, -1.5f, 0.4f, 0.4f, 135},
  };
  public Nce5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 1, -20, 0},
    {0, 0, 1, -20, 15},
    {0, 0, 1, -1, 30},
    {0, 0, 1, -1, 45},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[3][0] = ed.args[0]*2;
    mdSeed[1][0] = mdSeed[2][0] = ed.args[0];
    mdSeed[0][1] = mdSeed[3][1] = ed.args[1]*2;
    mdSeed[1][1] = mdSeed[2][1] = ed.args[1];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, 0, 0.3f, -2.0f, 0, 1, 0, 15},
    {1, 0, 0.3f, 2.0f, 0, 1, -1, 15},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
