package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Nst5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 3.0f, 0.2f, 0}, {0, 0, 3.0f, 0.2f, 90},
    {0, 1.0f, 1.0f, 0.3f, 10}, {0, -1.0f, 1.0f, 0.3f, 10},
  };
  public Nst5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -15, 0.5f, 0, 0},
    {0, 4, 1, 0, 10},
    {0, 4, 1, 0, 30},
    {0, 4, 2, 0, 40},
    {0, 4, 2, 0, 60},
    {0, 4, 3, 0, 70},
    {0, 4, 3, 0, 90},
    {0, -15, 3.5f, 0, 100},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {2,   0, 0.3f, 0, 0, 2, 0, 10},
    {2,  90, 0.3f, 0, 0, 2, 0, 10},
    {2, 180, 0.3f, 0, 0, 2, 0, 10},
    {2, 270, 0.3f, 0, 0, 2, 0, 10},
    {2,   0, 0.3f, 0, 0, 2, -1, 10},
    {2,   0, 0.3f, 0, 0, 2, 0, 40},
    {2,  90, 0.3f, 0, 0, 2, 0, 40},
    {2, 180, 0.3f, 0, 0, 2, 0, 40},
    {2, 270, 0.3f, 0, 0, 2, 0, 40},
    {2,   0, 0.3f, 0, 0, 2, -1, 40},
    {2,   0, 0.3f, 0, 0, 2, 0, 70},
    {2,  90, 0.3f, 0, 0, 2, 0, 70},
    {2, 180, 0.3f, 0, 0, 2, 0, 70},
    {2, 270, 0.3f, 0, 0, 2, 0, 70},
    {2,   0, 0.3f, 0, 0, 2, -1, 70},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[1][6] = bdSeed[2][6] = bdSeed[3][6]
     = bdSeed[5][6] = bdSeed[6][6] = bdSeed[7][6] = bdSeed[8][6]
     = bdSeed[10][6] = bdSeed[11][6] = bdSeed[12][6] = bdSeed[13][6]
     = ed.args[0];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.2f, 1.2f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1500;
    if ( ed.shield == -1 ) ed.shield = 50;
  }
}
