package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class OclM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 3.5f, 3.0f, 0.5f, 10}, {2, 1.75f, 3.0f, 0.5f, 130},
    {2, -1.75f, 3.0f, 0.5f, 70}, {0, -3.5f, 3.0f, 0.5f, 10},
    {-2, -1.75f, 3.0f, 0.5f, 130}, {-2, 1.75f, 3.0f, 0.5f, 70},
  };
  public OclM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 10, 180, 0},
    {0, 6, 1, -2, 30},
    {0, 6, 1, -2, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[12*7+15*7+9*7*2][8];
  final private float[][] btPst = {
    {-2, 3.5f}, {2, 3.5f}, {4, 0}, {2, -3.5f}, {-2, -3.5f}, {-4, 0},
    {-2, 3.5f}};
  public void makeBulletData(BltData[] bltData) {
    int idx = 0, yc = 0;
    for ( int i=0 ; i<12 ; i++ ) {
      for ( int j=0 ; j<7 ; j++ ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = btPst[j][0];
        bdSeed[idx][4] = btPst[j][1];
        bdSeed[idx][5] = 3;
        if ( j < 6 ) {
          if ( j == yc ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = 1;
          }
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = i*30+30;
        idx++;
      }
      yc++; if ( yc > 5 ) yc = 0;
    }
    for ( int i=0 ; i<15 ; i++ ) {
      for ( int j=0 ; j<7 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = btPst[j][0];
        bdSeed[idx][4] = btPst[j][1];
        bdSeed[idx][5] = 3;
        if ( j < 6 ) {
          if ( j == yc ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = 1;
          }
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = i*35+400;
        idx++;
      }
      yc++; if ( yc > 5 ) yc = 0;
    }
    for ( int i=0 ; i<9 ; i++ ) {
      for ( int j=0 ; j<7 ; j++ ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = btPst[j][0];
        bdSeed[idx][4] = btPst[j][1];
        bdSeed[idx][5] = 3;
        if ( j < 6 ) {
          if ( j == yc ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = 1;
          }
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = i*60+1000;
        idx++;
      }
      yc++; if ( yc > 5 ) yc = 0;
    }
    for ( int i=0 ; i<9 ; i++ ) {
      for ( int j=0 ; j<7 ; j++ ) {
        bdSeed[idx][0] = 1;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = btPst[j][0];
        bdSeed[idx][4] = btPst[j][1];
        bdSeed[idx][5] = 3;
        if ( j < 6 ) {
          if ( j == yc ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = 1;
          }
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = i*60+1600;
        idx++;
      }
      yc++; if ( yc > 5 ) yc = 0;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 3.0f, 3.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 150000;
    if ( ed.shield == -1 ) ed.shield = 2000;
  }
}
