package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class OclP1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 2, 2.0f, 0.5f, 10}, {0, -2, 2.0f, 0.5f, 10},
    {2, 0, 2.0f, 0.5f, 100}, {-2, 0, 2.0f, 0.5f, 100},
    {0, -1, 1.0f, 1.0f, 90},
  };
  public OclP1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 0.2f, 0, 0},
    {0, 12, 1, 0, 30},
    {-5, 9, 1, 0, 60},
    {-5, 3, 1, 0, 120},
    {0, 0, 1, 0, 150},
    {5, 3, 1, 0, 180},
    {5, 9, 1, 0, 210},
    {0, 12, 1, 0, 240},
    {-5, 9, 1, 0, 270},
    {-5, 3, 1, 0, 300},
    {0, 0, 1, 0, 330},
    {12, 0, 1, 0, 400},
    {-12, 0, 1, 0, 500},
    {12, 0, 1, 0, 600},
    {-12, 0, 1, 0, 700},
    {12, 0, 1, 0, 800},
    {-12, 0, 1, 0, 900},
    {0, 10, 1, -5, 1000},
    {-10, 5, 1, -5, 1100},
    {-10, -5, 1, -5, 1200},
    {0, -10, 1, -5, 1300},
    {10, -5, 1, -5, 1400},
    {10, 5, 1, -5, 1500},
    {0, 10, 1, -5, 1600},
    {-10, 0, 1, -1, 1700},
    {0, 3, 1, -1, 1800},
    {10, 0, 1, -1, 1900},
    {-10, 0, 1, -1, 2100},
    {0, 3, 1, -1, 2200},
    {0, 0, 1, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[40+32+16*4+16*3][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<20 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = -1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 30+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 1.0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 30+i*15;
      idx++;
    }
    for ( int i=0 ; i<32 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.5f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 4;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 400+(i%4)*12+(int)(i/4)*60;
      idx++;
    }
    for ( int i=0 ; i<16 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 315;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1000+i*30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 45;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1000+i*30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = -1.5f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 1000+i*30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 1.5f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1000+i*30;
      idx++;
    }
    for ( int i=0 ; i<16 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 340;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 1600+i*30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 1600+i*30;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 20;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 0f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1600+i*30;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.0f, 2.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
