package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class PngM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 4, 8, 1, 0}, {-3, 0, 6, 1, 100}, {3, 0, 6, 1, 80},
    {0, -4, 5, 1, 0},
    {-0.5f, 0.5f, 1, 0.3f, 45}, {0.5f, 0.5f, 1, 0.3f, 135},
    {0.5f, -0.5f, 1, 0.3f, 45}, {-0.5f, -0.5f, 1, 0.3f, 135},
  };
  public PngM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -15, 0.5f, 0, 0},
    {0, 8, 1, 0, 100},
    {2, 7, 1, 0, 130},
    {-2, 7, 1, 0, 190},
    {2, 9, 1, 0, 250},
    {-2, 9, 1, 0, 310},
    {0, 8, 1, 0, 340},
    {100, 0, -99999, 0, 340},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  private float adjustDeg(float d) {
    if ( d >= 0 ) {
      return (d%360);
    } else {
      return (359-(Math.abs(d)%360));
    }
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[1000][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    float d1 = 180, d2 = 180;
    for ( int i=0 ; i<25 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d1);
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 1;
      bdSeed[idx][7] = 120+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d1+30f);
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 120+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(-d2);
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 1;
      bdSeed[idx][7] = 120+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(-d2-20f);
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 120+i*15;
      idx++;
      d1 += 80f; d2 += 40f;
    }
    for ( int i=0 ; i<30 ; i++ ) {
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d1);
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 620+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(d1+30f);
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 620+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(-d2);
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = 627+i*15;
      idx++;
      bdSeed[idx][0] = 2;
      bdSeed[idx][1] = adjustDeg(-d2-20f);
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 627+i*15;
      idx++;
      d1 += 80f; d2 += 40f;
    }
    d1 = 180;
    for ( int j=0 ; j<5 ; j++ ) {
      for ( int i=0 ; i<30 ; i++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = adjustDeg(d1);
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1220+i+j*90;
        idx++;
        d1 += 12;
      }
      for ( int i=0 ; i<30 ; i++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = adjustDeg(d1);
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1250+i+j*90;
        idx++;
        d1 += 12;
      }
    }
    for ( int j=0 ; j<8 ; j++ ) {
      for ( int i=0 ; i<30 ; i++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = adjustDeg(d1);
        bdSeed[idx][2] = 0.2f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1820+i+j*60;
        idx++;
        d1 += 12;
      }
      for ( int i=0 ; i<30 ; i++ ) {
        bdSeed[idx][0] = 2;
        bdSeed[idx][1] = adjustDeg(d1);
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1850+i+j*60;
        idx++;
        d1 += 12;
      }
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.5f, 0.5f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 100000;
    if ( ed.shield == -1 ) ed.shield = 3000;
  }
}
