package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class PngP1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 5, 8, 1, 20}, {1, -4, 7, 1, 30},
    {-3, -1, 8, 1, 100}, {4.2f, 1.8f, 7, 1, 95},
  };
  public PngP1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {-8, -19, 10, 0, 0},
    {-8, -19, 10, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[184][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<20 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 2;
        bdSeed[idx][7] = 120+i*20;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 120+i*20;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = -4;
      bdSeed[idx][4] = 4;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 120+i*20;
      idx++;
    }
    for ( int i=0 ; i<24 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = 620+i*20;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 620+i*20;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = -4;
      bdSeed[idx][4] = 4;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 620+i*20;
      idx++;
    }
    for ( int i=0 ; i<24 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = 1220+i*20;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1220+i*20;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = -4;
      bdSeed[idx][4] = 4;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1220+i*20;
      idx++;
    }
    for ( int i=0 ; i<24 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1820+i*20;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = -2.5f;
        bdSeed[idx][4] = -4.5f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1820+i*20;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = -4;
      bdSeed[idx][4] = 4;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1820+i*20;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
