package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class PngP2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 2.5f, 4, 1, 340}, {-0.5f, -2, 3.5f, 1, 330},
    {1.5f, -0.5f, 4, 1, 260}, {-2.1f, 0.9f, 3.5f, 1, 265},
  };
  public PngP2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {6, -17, 10, 0, 0},
    {6, -17, 10, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[92][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<10 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 2;
        bdSeed[idx][7] = 120+i*40;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 120+i*40;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = 2;
      bdSeed[idx][4] = 2;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 120+i*40;
      idx++;
    }
    for ( int i=0 ; i<12 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = 620+i*40;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 620+i*40;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = 2;
      bdSeed[idx][4] = 2;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 620+i*40;
      idx++;
    }
    for ( int i=0 ; i<12 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = 0;
        bdSeed[idx][7] = 1220+i*40;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1220+i*40;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = 2;
      bdSeed[idx][4] = 2;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1220+i*40;
      idx++;
    }
    for ( int i=0 ; i<12 ; i++ ) {
      if ( (i%2)==0 ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1820+i*40;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 7;
        bdSeed[idx][2] = 0.25f;
        bdSeed[idx][3] = 1.25f;
        bdSeed[idx][4] = -2.75f;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = 1820+i*40;
        idx++;
      }
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = 2;
      bdSeed[idx][4] = 2;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 1820+i*40;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
