package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Pwd2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 3.0f, 0.7f, 0.2f, 0},
    {-1.0f, 2.5f, 0.7f, 0.2f, 90}, {1.0f, 2.5f, 0.7f, 0.2f, 90},
    {0, 2.0f, 0.7f, 0.2f, 0},
    {0, -3.0f, 0.7f, 0.2f, 0},
    {-1.0f, -2.5f, 0.7f, 0.2f, 90}, {1.0f, -2.5f, 0.7f, 0.2f, 90},
    {0, -2.0f, 0.7f, 0.2f, 0},
  };
  public Pwd2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, -10, 1.2f, 0, 0},
    {0, 7, 1, 170, 60},
    {0, 8, 1, 340, 120},
    {0, 9, 1, 150, 180},
    {0, -10, 0.2f, 320, 240},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.3f, 0, 3f, 1, 0, 60},
    {0, 0, 0.3f, 0, -3f, 1, -1, 60},
    {0, 0, 0.3f, 0, 3f, 1, 0, 90},
    {0, 0, 0.3f, 0, -3f, 1, -1, 90},
    {0, 0, 0.3f, 0, 3f, 1, 0, 120},
    {0, 0, 0.3f, 0, -3f, 1, -1, 120},
    {0, 0, 0.3f, 0, 3f, 1, 0, 150},
    {0, 0, 0.3f, 0, -3f, 1, -1, 150},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0, 0}, {0, 2.5f, 1.0f, 1.0f}, {0, -2.5f, 1.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 500;
    if ( ed.shield == -1 ) ed.shield = 80;
  }
}
