package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Rup3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.6f, 1.0f, 1.0f, 0.3f, 30}, {0.6f, 1.0f, 1.0f, 0.3f, 330},
    {-0.6f, -1.0f, 1.0f, 0.3f, 330}, {0.6f, -1.0f, 1.0f, 0.3f, 30},
  };
  public Rup3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 0.2f, 180, 0},
    {0, 0, 1, 0, 15},
    {0, 0, 1, 0, 45},
    {0, 0, 1, 0, 75},
    {0, 0, 1.8f, 0, 90},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = mdSeed[4][0]
     = ed.args[0];
    mdSeed[0][1] = mdSeed[1][1] = mdSeed[2][1] = mdSeed[3][1] = mdSeed[4][1]
     = ed.args[1];
    switch ( (int)ed.args[2] ) {
      case 0:
        mdSeed[1][3] = 330;
        mdSeed[2][3] = 60;
        mdSeed[3][3] = 150;
        mdSeed[4][3] = 300;
        break;
      case 1:
        mdSeed[1][3] = 30;
        mdSeed[2][3] = 300;
        mdSeed[3][3] = 210;
        mdSeed[4][3] = 60;
        break;
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[20][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<10 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = -5;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 3;
      bdSeed[idx][6] = 1;
      bdSeed[idx][7] = i*7+15;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 5;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 3;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*7+15;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.2f, 1.2f}
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1200;
    if ( ed.shield == -1 ) ed.shield = 30;
  }
}
