package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Stt2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 1.0f, 0.4f, 0},
    {0, 0, 1.0f, 0.4f, 90},
    {-0.4f, 0.6f, 0.6f, 0.3f, 45},
    {0.4f, 0.6f, 0.6f, 0.3f, 315},
  };
  public Stt2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 12, 0.5f, 0, 0}, {0, 4, 1f, 0, 30},
    {0, 6, 1f, 0, 60}, {0, 12, 1f, 0, 120},
  };
  public void makeManeuver(MnvData[] mnvData) {
    float sx = ed.args[0];
    mdSeed[0][0] = sx*3; mdSeed[1][0] = sx*2;
    mdSeed[2][0] = -sx; mdSeed[3][0] = -sx*2;
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, -14, 0.2f, 0, 0, 3, 0, 30},
    {0, 0, 0.2f, 0, 0, 3, 0, 30},
    {0, 14, 0.2f, 0, 0, 3, -1, 30},
    {0, -14, 0.2f, 0, 0, 3, 0, 40},
    {0, 0, 0.2f, 0, 0, 3, 0, 40},
    {0, 14, 0.2f, 0, 0, 3, -1, 40},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[4][6] = ed.args[1];
    bdSeed[1][6] = bdSeed[3][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 0.7f, 0.7f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 700;
    if ( ed.shield == -1 ) ed.shield = 15;
  }
}
