package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Tar3 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 2.4f, 20f, 0.5f, 0}, {0, -2.4f, 20f, 0.5f, 0},
    {-9, 0, 1.0f, 1.0f, 90}, {-3, 0, 1.0f, 1.0f, 90},
    {9, 0, 1.0f, 1.0f, 90}, {3, 0, 1.0f, 1.0f, 90},
  };
  public Tar3() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 1.8f, 179, 0},
    {0, 0, 1f, 0, 60},
    {0, 0, 1f, 0, 180},
    {0, 0, 0.2f, 181, 240},
  };
  public void makeManeuver(MnvData[] mnvData) {
    switch ( (int)ed.args[0] ) {
      case 0:
        mdSeed[1][0] = mdSeed[2][0] = 0;
        mdSeed[1][1] = mdSeed[2][1] = 10;
        mdSeed[1][3] = mdSeed[2][3] = 0;
        break;
      case 1:
        mdSeed[1][0] = mdSeed[2][0] = 10;
        mdSeed[1][1] = mdSeed[2][1] = 0;
        mdSeed[1][3] = mdSeed[2][3] = 270;
        break;
      case 2:
        mdSeed[1][0] = mdSeed[2][0] = -10;
        mdSeed[1][1] = mdSeed[2][1] = 0;
        mdSeed[1][3] = mdSeed[2][3] = 90;
        break;
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[45][8];
  int[][] clPtn = {
    {0, 1, 0, 2, 0, 1, 0, 2, 0, 1},
    {0, 0, 1, 2, 1, 0, 0, 1, 2, 1},
  };
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    int clIdx = (int)ed.args[1];
    for ( int i=0 ; i<5 ; i++ ) {
      for ( int j=0 ; j<9 ; j++ ) {
        if ( (i&1)==0 ) {
          if ( clIdx >= 10 ) clIdx -= 10;
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = 0;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = j*3-12;
          bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( j == 8 ) {
            bdSeed[idx][6] = -1;
          } else {
            bdSeed[idx][6] = clPtn[i&1][clIdx];
          }
          bdSeed[idx][7] = i*30+60;
          clIdx++;
        } else {
          bdSeed[idx][0] = 0;
          bdSeed[idx][1] = 10*((j&1)*2-1);
          bdSeed[idx][2] = 0.2f;
          bdSeed[idx][3] = j*3-12;
          bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 0;
          bdSeed[idx][6] = -1;
          bdSeed[idx][7] = i*30+40;
        }
        idx++;
      }
      clIdx += ed.args[2];
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 3.0f, 3.0f},
    {3, 0, 3.0f, 3.0f},
    {6, 0, 3.0f, 3.0f},
    {9, 0, 3.0f, 3.0f},
    {12, 0, 3.0f, 3.0f},
    {-3, 0, 3.0f, 3.0f},
    {-6, 0, 3.0f, 3.0f},
    {-9, 0, 3.0f, 3.0f},
    {-12, 0, 3.0f, 3.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
