package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class TrtM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 0, 2.0f, 0.4f, 60},
    { 1.0f, 0, 2.0f, 0.4f, 120},
    {0, -1.0f, 2.0f, 0.4f, 0},
    {0, 3, 7.0f, 0.3f, 0},
    {-2.0f, -1.0f, 7.0f, 0.3f, 120},
    {2.0f, -1.0f, 7.0f, 0.3f, 60},
  };
  public TrtM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 12, 2.0f, 180, 0},
    {0, 7, 1.0f, 0, 100},
    {0, 7, 1.0f, 0, 99999},
    {100, 0, -99999, 0, 99999}
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[111][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<10 ; i++ ) {
      for ( int j=0 ; j<5 ; j++ ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = j*20-40;
        bdSeed[idx][2] = 0.3f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = i*50+200 ;
        idx++;
      }
      for ( int j=0 ; j<3 ; j++ ) {
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = j*20-20;
        bdSeed[idx][2] = 0.5f;
        bdSeed[idx][3] = bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = i*50+200+25;
        idx++;
      }
    }
    for ( int i=0 ; i<10 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.15f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*50+200+600;
      idx++;
    }
    for ( int j=0 ; j<5 ; j++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = j*15-30;
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 2;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 200+1200;
      idx++;
    }
    for ( int j=0 ; j<3 ; j++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = j*15-15;
      bdSeed[idx][2] = 0.5f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 200+1200+25;
      idx++;
    }
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 200+1200-1;
    bdSeed[idx][7] = 200+1200+50;
    idx++;
    for ( int j=0 ; j<7 ; j++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = j*15-45;
      bdSeed[idx][2] = 0.4f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 25;
      idx++;
    }
    for ( int j=0 ; j<4 ; j++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = j*15-22.5f;
      bdSeed[idx][2] = 0.6f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 50;
      idx++;
    }
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 50;
    idx++;
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 80000;
    if ( ed.shield == -1 ) ed.shield = 500;
  }
}
