package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class TrtP extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 1.0f, 2.0f, 0.4f, 45},
    {1.0f, 1.0f, 2.0f, 0.4f, 135},
    {1.0f, -1.0f, 2.0f, 0.4f, 225},
    {-1.0f, -1.0f, 2.0f, 0.4f, 315},
    {0, 0, 2.0f, 0.4f, 0},
  };
  public TrtP() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 0.5f, 0, 0},
    {0, 0, 1, 0, 30},
    {0, 0, 1, 0, 400},
    {0, 0, 2, 0, 430},
    {0, 0, 2, 0, 500},
    {0, 0, 2.5f, 0, 530},

    {0, 0, 0, 0, -1},
    {0, 0, 2, 0, 0},
    {0, 0, 2, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    for ( int i=0 ; i<8 ; i++ ) {
      mdSeed[i][0] = ed.args[0];
      mdSeed[i][1] = ed.args[1];
    }
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[120][8];

  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<4 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        int tm = 30+j*10+i*80;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -15;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( j == 0 ) {
          bdSeed[idx][6] = ed.args[2];
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( j == 0 ) {
          bdSeed[idx][6] = -1;
        } else {
          bdSeed[idx][6] = ed.args[2];
        }
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 15;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
      }
    }
    float[] dTbl = {
      -10, 0, 0, 10, -30, -20, 20, 30, -50, -40, 40, 50,
      -40, -30, 30, 40, -20, -10, 10, 20};
    for ( int i=0 ; i<10 ; i++ ) {
      int tm = 600+i*50;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = dTbl[i*2];
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = ed.args[2];
      bdSeed[idx][7] = tm;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = dTbl[i*2+1];
      bdSeed[idx][2] = 0.3f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = tm;
      idx++;
    }
    for ( int i=0 ; i<6 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        int tm = 30+j*10+i*80+1200;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = -15;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( j == 0 ) {
          bdSeed[idx][6] = ed.args[2];
        } else {
          bdSeed[idx][6] = -1;
        }
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 0;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        if ( j == 0 ) {
          bdSeed[idx][6] = -1;
        } else {
          bdSeed[idx][6] = ed.args[2];
        }
        bdSeed[idx][7] = tm;
        idx++;
        bdSeed[idx][0] = 0;
        bdSeed[idx][1] = 15;
        bdSeed[idx][2] = 0.2f+j*0.3f;
        bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
        bdSeed[idx][5] = 0;
        bdSeed[idx][6] = -1;
        bdSeed[idx][7] = tm;
        idx++;
      }
    }
    for ( int i=0 ; i<20 ; i++ ) {
      int tm = 1800+i*60;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = dTbl[(i*2)%20]/3;
      bdSeed[idx][2] = 0.5f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = tm;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = dTbl[(i*2+1)%20]/3;
      bdSeed[idx][2] = 0.5f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 1;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = tm;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.5f, 1.5f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 7000;
    if ( ed.shield == -1 ) ed.shield = 500;
  }
}
