package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class TrtP2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0.5f, -0.5f, 1.0f, 0.3f, 225},
    {-0.5f, -0.5f, 1.0f, 0.3f, 315},
    {0, 0, 1.0f, 0.3f, 0},
  };
  public TrtP2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 11, 2f, 0, 0},
    {0, 11, 2f, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[25][8];

  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    bdSeed[idx][0] = 0;
    bdSeed[idx][1] = -15;
    bdSeed[idx][2] = 0.15f;
    bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
    bdSeed[idx][5] = 0;
    bdSeed[idx][6] = -1;
    bdSeed[idx][7] = 20;
    idx++;
    bdSeed[idx][0] = 0;
    bdSeed[idx][1] = 15;
    bdSeed[idx][2] = 0.15f;
    bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
    bdSeed[idx][5] = 0;
    bdSeed[idx][6] = -1;
    bdSeed[idx][7] = 40;
    idx++;
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 40;
    idx++;
    for ( int i=0 ; i<10 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = -15;
      bdSeed[idx][2] = 0.8f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 2+i*4;
      idx++;
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 15;
      bdSeed[idx][2] = 0.8f;
      bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = 4+i*4;
      idx++;
    }
    bdSeed[idx][0] = 0;
    bdSeed[idx][1] = 0;
    bdSeed[idx][2] = 0.6f;
    bdSeed[idx][3] = 0; bdSeed[idx][4] = 0;
    bdSeed[idx][5] = 0;
    bdSeed[idx][6] = -1;
    bdSeed[idx][7] = 40;
    idx++;
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 40;
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
