package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Typ4 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.4f, 0, 1.0f, 0.3f, 90}, {0.4f, 0, 1.0f, 0.3f, 90},
    {-0.8f, 0.4f, 1.0f, 0.3f, 45}, {0.8f, 0.4f, 1.0f, 0.3f, 135},
    {-0.8f, -0.4f, 1.0f, 0.3f, 135}, {0.8f, -0.4f, 1.0f, 0.3f, 45},
  };
  public Typ4() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 14, 0.9f, -10, 0},
    {0, 12, 1, -10, 15},
    {0, -12, 1, -10, 195},
    {0, -14, 0.9f, -10, 210},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[8][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<8 ; i++ ) {
      bdSeed[idx][0] = 0;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      //bdSeed[idx][7] = i*12+15;
      bdSeed[idx][7] = i*18+15;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.2f, 1.2f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 800;
    if ( ed.shield == -1 ) ed.shield = 30;
  }
}
