package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Upt4 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 0, 0.5f, 0.3f, 80}, {0, 0, 0.5f, 0.3f, 90},
    {1.0f, 0, 0.5f, 0.3f, 100}, {0, 0.5f, 1.8f, 0.1f, 0},
  };
  public Upt4() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 14, 0.9f, -10, 0},
    {0, 12, 1, -10, 15},
    {0, 6, 1, -10, 75},
    {0, 4, 0.4f, -10, 90},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[9][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<3 ; i++ ) {
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = -2;
      bdSeed[idx][2] = 0.225f;
      bdSeed[idx][3] = -1.5f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = i*25+15;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 0;
      bdSeed[idx][2] = 0.25f;
      bdSeed[idx][3] = 0;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = 0;
      bdSeed[idx][7] = i*25+15;
      idx++;
      bdSeed[idx][0] = 1;
      bdSeed[idx][1] = 2;
      bdSeed[idx][2] = 0.2f;
      bdSeed[idx][3] = 1.5f;
      bdSeed[idx][4] = 0;
      bdSeed[idx][5] = 0;
      bdSeed[idx][6] = -1;
      bdSeed[idx][7] = i*25+15;
      idx++;
    }
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.2f, 0.6f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1000;
    if ( ed.shield == -1 ) ed.shield = 50;
  }
}
