package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Uue5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, -1.5f, 4.0f, 0.3f, 0}, {0, 1.5f, 4.0f, 0.3f, 0},
    {-1.5f, 0, 4.0f, 0.3f, 90}, {1.5f, 0, 4.0f, 0.3f, 90},
    {0, 0, 4.0f, 0.3f, 90},
  };
  public Uue5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 0, 2.5f, 0, 0},
    {0, 0, 2, 0, 15},
    {0, 0, 2, -1f, 45},
    {0, 0, 1, 0, 60},
    {0, 0, 1, -1f, 90},
    {0, 0, 0.5f, 0, 105},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[5][0] = ed.args[0]*2;
    mdSeed[0][1] = mdSeed[5][1] = ed.args[1]*2;
    mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = mdSeed[4][0] = ed.args[0];
    mdSeed[1][1] = mdSeed[2][1] = mdSeed[3][1] = mdSeed[4][1] = ed.args[1];
    mdSeed[0][3] = mdSeed[1][3] = mdSeed[3][3] = mdSeed[5][3] = ed.args[2];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 15},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 23},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 31},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 39},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 60},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 68},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 76},
    {1, 0, 0.5f, 0, -2.0f, 4, -1, 84},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.0f, 2.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 700;
    if ( ed.shield == -1 ) ed.shield = 15;
  }
}
