package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class XldM extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 0, 5.0f, 0.5f, 90}, {1.0f, 0, 5.0f, 0.5f, 90},
    {0, -3.0f, 1.0f, 0.5f, 0},
    {0, 3.5f, 5.0f, 0.5f, 90},
    {-2.0f, 2.0f, 4.0f, 0.8f, 135}, {2.0f, 2.0f, 4.0f, 0.8f, 45},
  };
  public XldM() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 10, 0.2f, -10, 0},
    {0, 10, 1, -10, 60},
    {0, 10, 1, -10, 120},
    {0, 10, 2, -10, 180},
    {0, 10, 2, -10, 240},
    {0, 10, 3, -10, 300},
    {0, 10, 3, -10, 360},
    {0, 10, 3.8f, -10, 420},

    {0, 0, 0, 0, -1},
    {0, 10, 3, -10, 0},
    {0, 10, 3, -10, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = new float[78+52*3+3][8];
  public void makeBulletData(BltData[] bltData) {
    int idx = 0;
    for ( int i=0 ; i<3 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        for ( int k=0 ; k<7 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*10-30;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( k < 6 ) {
            switch (i%2) {
              case 0:
                if ( (k%2) == 0 ) {
                  bdSeed[idx][6] = i;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
              case 1:
                if ( (k%2) == 1 ) {
                  bdSeed[idx][6] = i;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
            }
          } else {
             bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*120 + j*40 + 60;
          idx++;
        }
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*10-25;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( (k%2) == 0 ) {
            bdSeed[idx][6] = i;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*120 + j*40 + 60 + 10;
          idx++;
        }
      }
    }
    for ( int i=0 ; i<2 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        for ( int k=0 ; k<7 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*10-30;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( k < 6 ) {
            switch (i%2) {
              case 0:
                if ( (k%2) == 0 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
              case 1:
                if ( (k%2) == 1 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
            }
          } else {
             bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*120 + j*40 + 600 + 120;
          idx++;
        }
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*10-25;
          bdSeed[idx][2] = 0.3f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( (k%2) == 0 ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*120 + j*40 + 600 + 10 + 120;
          idx++;
        }
      }
    }
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 600;
    bdSeed[idx][7] = 890;
    idx++;
    for ( int i=0 ; i<2 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        for ( int k=0 ; k<7 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*8-24;
          bdSeed[idx][2] = 0.35f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( k < 6 ) {
            switch (i%2) {
              case 0:
                if ( (k%2) == 0 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
              case 1:
                if ( (k%2) == 1 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
            }
          } else {
             bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*100 + j*30 + 100;
          idx++;
        }
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*8-20;
          bdSeed[idx][2] = 0.35f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( (k%2) == 0 ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*100 + j*30 + 10 + 100;
          idx++;
        }
      }
    }
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 240;
    idx++;
    for ( int i=0 ; i<2 ; i++ ) {
      for ( int j=0 ; j<2 ; j++ ) {
        for ( int k=0 ; k<7 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*6-18;
          bdSeed[idx][2] = 0.4f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( k < 6 ) {
            switch (i%2) {
              case 0:
                if ( (k%2) == 0 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
              case 1:
                if ( (k%2) == 1 ) {
                  bdSeed[idx][6] = 2;
                } else {
                  bdSeed[idx][6] = -1;
                }
                break;
            }
          } else {
             bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*80 + j*25 + 80;
          idx++;
        }
        for ( int k=0 ; k<6 ; k++ ) {
          bdSeed[idx][0] = 1;
          bdSeed[idx][1] = k*6-15;
          bdSeed[idx][2] = 0.4f;
          bdSeed[idx][3] = bdSeed[idx][4] = 0;
          bdSeed[idx][5] = 1;
          if ( (k%2) == 0 ) {
            bdSeed[idx][6] = 2;
          } else {
            bdSeed[idx][6] = -1;
          }
          bdSeed[idx][7] = i*80 + j*25 + 10 + 80;
          idx++;
        }
      }
    }
    bdSeed[idx][0] = -1;
    bdSeed[idx][1] = 0;
    bdSeed[idx][7] = 195;
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 2.5f, 2.5f}, {0, -1.2f, 1.0f, 1.0f}, {0, -2.2f, 1.0f, 1.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 100000;
    if ( ed.shield == -1 ) ed.shield = 1200;
  }
}
