package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class XldP1 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-0.5f, -2.0f, 3.0f, 0.3f, 110}, {0.5f, -2.0f, 3.0f, 0.3f, 70},
    {-0.5f, 1.0f, 1.0f, 0.3f, 45}, {0.5f, 1.0f, 1.0f, 0.3f, 135},
  };
  public XldP1() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 14, 0.9f, -10, 0},
    {0, 12, 1, -10, 15},
    {0, 6, 1, -10, 60},
    {0, 6, 1, -10, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    mdSeed[2][1] = mdSeed[3][1] = 6 - ed.args[1];
    mdSeed[2][4] = 60 + ed.args[1]*7.5f;
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, -15, 0.3f, 0, 0, 2, 0, 120},
    {1, 5, 0.3f, 0, 0, 2, -1, 120},
    {1, -5, 0.3f, 0, 0, 2, 0, 140},
    {1, 15, 0.3f, 0, 0, 2, -1, 140},
    {1, 0, 0.3f, 0, 0, 2, -1, 160},
    {1, 0, 0.3f, 0, 0, 2, -1, 180},
    {-1, 0, 0, 0, 0, 0, 0, 180},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.5f, 2.0f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 10000;
    if ( ed.shield == -1 ) ed.shield = 200;
  }
}
