package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class XldP2 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {0, 0, 2.0f, 0.5f, 0},
    {-0.4f, -0.8f, 2.0f, 0.3f, 20},
    {0.4f, -0.8f, 2.0f, 0.3f, 340},
  };
  public XldP2() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 14, 0.9f, 0, 0},
    {0, 12, 1, 0, 15},
    {0, 10, 1, 0, 30},
    {0, 10, 1, 0, 99999},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {0, 0, 0.5f, 0, -2, 4, -1, 36},
    {0, 0, 0.5f, 0, -2, 4, -1, 44},
    {0, 0, 0.5f, 0, -2, 4, -1, 52},
    {0, 0, 0.5f, 0, -2, 4, -1, 60},
    {-1, 0, 0, 0, 0, 0, 0, 60},
    {0, 0, 0.5f, 0, -2, 4, -1, 20},
    {0, 0, 0.5f, 0, -2, 4, -1, 28},
    {0, 0, 0.5f, 0, -2, 4, -1, 36},
    {0, 0, 0.5f, 0, -2, 4, -1, 44},
    {0, 0, 0.5f, 0, -2, 4, -1, 52},
    {0, 0, 0.5f, 0, -2, 4, -1, 60},
    {-1, 0, 0, 0, 0, 0, 0, 60},
  };
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, -99999, -99999},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 0;
    if ( ed.shield == -1 ) ed.shield = 99999;
  }
}
