package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Zako4 extends CraftGenerator {

  float[][] spData = {
   {0, 0.8f, 1f, 0.4f, 0}, {0, -0.8f, 1f, 0.4f, 0},
   {0.8f, 0, 1f, 0.4f, 90}, {-0.8f, 0, 1f, 0.4f, 90},
   {0.8f, -1.0f, 0.5f, 0.4f, 60}, {-0.8f, -1.0f, 0.5f, 0.4f, 300},
  };
  public Zako4() {
    shape = new DigitalShape(spData);
  }

  float[][] mdSeed = {
   {0, 20.0f, 2.5f, 0, 0}, {0, 6.0f, 2f, 0, 10},
   {0, 2.0f, 2f, 0, 40}, {0, 0, 1f, 180, 50},
   {0, 4.0f, 1f, 180, 80}, {0, 15.0f, 0.1f, 180, 100}};
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0]= mdSeed[4][0]
     = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  float[][] bdSeed = {
   {0, -10, 0.2f, 0, 0, 0, -1, 10}, {0, 10, 0.2f, 0, 0f, 0, -1, 10},
   {0, 0, 0.2f, 0, 0, 0, -1, 40},
   {0, -10, 0.2f, 0, 0, 0, -1, 50}, {0, 10, 0.2f, 0, 0f, 0, -1, 50},
   {0, 0, 0.2f, 0, 0, 0, -1, 80}};
  public void makeBulletData(BltData[] bltData) {
    setBulletData(bltData, bdSeed);
  }

  float[][] cdSeed = {
   {0, 0, 0.8f, 0.8f}};
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 500;
    if ( ed.shield == -1 ) ed.shield = 10;
  }
}
