package jp.gr.java_conf.abagames.comraid.crafts;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.shapes.*;
import jp.gr.java_conf.abagames.util.gl4j.*;

public class Zip5 extends CraftGenerator {

  // x, y, length, width, deg
  float[][] spData = {
    {-1.0f, 1.0f, 1.5f, 0.2f, 45},
    {1.0f, 1.0f, 1.5f, 0.2f, 135},
    {-1.0f, -1.0f, 1.5f, 0.2f, 135},
    {1.0f, -1.0f, 1.5f, 0.2f, 45},
  };
  public Zip5() {
    shape = new DigitalShape(spData);
  }

  //      x, y,  layer,    deg, time
  //       ,  ,       , -mvdeg,
  // bkTime,  , -99999,       ,
  float[][] mdSeed = {
    {0, 15, 3.9f, -10, 0},
    {0, 10, 3, -10, 30},
    {0, 10, 3, -10, 90},
    {0, 10, 2, -10, 120},
    {0, 10, 2, -10, 180},
    {0, 10, 1, -10, 210},
    {0, 10, 1, -10, 270},
    {0, 15, 0.1f, -10, 300},
  };
  public void makeManeuver(MnvData[] mnvData) {
    mdSeed[0][0] = mdSeed[1][0] = mdSeed[2][0] = mdSeed[3][0]
     = mdSeed[4][0] = mdSeed[5][0] = mdSeed[6][0] = mdSeed[7][0] = ed.args[0];
    setManueuverData(mnvData, mdSeed);
  }

  // type,    deg, speed, ofsX, ofsY, shape, engLine, time
  //   -1, bkTime,      ,     ,     ,      ,        ,
  float[][] bdSeed = {
    {1, 0, 0.3f, 0, 2.5f, 3, 0, 30},
    {1, 0, 0.3f, 2.5f, 0, 3, 0, 30},
    {1, 0, 0.3f, 0, -2.5f, 3, 0, 30},
    {1, 0, 0.3f, -2.5f, 0, 3, 0, 30},
    {1, 0, 0.3f, 0, 2.5f, 3, -1, 30},
    {1, 0, 0.3f, 0, 2.5f, 3, 0, 120},
    {1, 0, 0.3f, 2.5f, 0, 3, 0, 120},
    {1, 0, 0.3f, 0, -2.5f, 3, 0, 120},
    {1, 0, 0.3f, -2.5f, 0, 3, 0, 120},
    {1, 0, 0.3f, 0, 2.5f, 3, -1, 120},
    {1, 0, 0.3f, 0, 2.5f, 3, 0, 210},
    {1, 0, 0.3f, 2.5f, 0, 3, 0, 210},
    {1, 0, 0.3f, 0, -2.5f, 3, 0, 210},
    {1, 0, 0.3f, -2.5f, 0, 3, 0, 210},
    {1, 0, 0.3f, 0, 2.5f, 3, -1, 210},
  };
  public void makeBulletData(BltData[] bltData) {
    bdSeed[0][6] = bdSeed[2][6] = bdSeed[5][6]
     = bdSeed[7][6] = bdSeed[10][6] = bdSeed[12][6] = ed.args[1];
    bdSeed[1][6] = bdSeed[3][6] = bdSeed[6][6]
     = bdSeed[8][6] = bdSeed[11][6] = bdSeed[13][6] = ed.args[2];
    setBulletData(bltData, bdSeed);
  }

  // ofsX, ofsY, width, height
  float[][] cdSeed = {
    {0, 0, 1.5f, 1.5f},
  };
  public void makeCollisionData(ClsData[] clsData) {
    setCollisionData(clsData, cdSeed);
  }

  public void setCraftProperties(EngData ed) {
    ed.score = 1200;
    if ( ed.shield == -1 ) ed.shield = 20;
  }
}
