package jp.gr.java_conf.abagames.comraid.shapes;

import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;

public class BatteryShape implements IShape {
  final private float[][] vtxs = {
    {-1.0f, 0, 0}, {-0.5f, 0, 0}, {-0.3f, -0.6f, 0},
    {-0.3f, -1.0f, 0}, {-1.0f, -1.0f, 0},
    {1.0f, 0, 0}, {0.5f, 0, 0}, {0.3f, -0.6f, 0},
    {0.3f, -1.0f, 0}, {1.0f, -1.0f, 0},
    {0, 0.6f, 0}, {0.4f, 0, 0}, {0, -0.6f, 0}, {-0.4f, 0, 0}};

  public final void draw(GLFunc gl) {
    gl.glBegin(ShapeProperties.fnMode);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[4]);
    gl.glEnd();
    gl.glBegin(ShapeProperties.fnMode);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[8]);
    gl.glVertex3fv(vtxs[9]);
    gl.glEnd();
    gl.glBegin(ShapeProperties.fnMode);
    gl.glVertex3fv(vtxs[10]);
    gl.glVertex3fv(vtxs[11]);
    gl.glVertex3fv(vtxs[12]);
    gl.glVertex3fv(vtxs[13]);
    gl.glEnd();

    gl.glPushMatrix();
    gl.glRotatef(lfDeg, 1, 0, 0);
    gl.glBegin(GLFunc.GL_LINE_LOOP);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glVertex3fv(vtxs[4]);
    gl.glEnd();
    gl.glPopMatrix();
    gl.glPushMatrix();
    gl.glRotatef(rtDeg, 1, 0, 0);
    gl.glBegin(GLFunc.GL_LINE_LOOP);
    gl.glVertex3fv(vtxs[5]);
    gl.glVertex3fv(vtxs[6]);
    gl.glVertex3fv(vtxs[7]);
    gl.glVertex3fv(vtxs[8]);
    gl.glVertex3fv(vtxs[9]);
    gl.glEnd();
    gl.glPopMatrix();
  }

  private float lfDeg, rtDeg;

  public void setLeftDeg(float lfDeg) {
    this.lfDeg = lfDeg;
  }

  public void setRightDeg(float rtDeg) {
    this.rtDeg = rtDeg;
  }
}
