package jp.gr.java_conf.abagames.comraid.shapes;

import jp.gr.java_conf.abagames.util.gl4j.*;
import gl4java.*;
import java.util.Random;

public class EnergyLineShape implements IShape {
  static private Random rnd = new Random();

  private float[][] vtxs = {
    {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}};

  private float[] brcX = new float[2];
  private float[] brcY = new float[2];
  private float[] brcMX = new float[2];
  private float[] brcMY = new float[2];

  public EnergyLineShape() {
    for ( int i=1 ; i>=0 ; i-- ) {
      brcX[i] = (rnd.nextInt()%100)*0.01f;
      brcY[i] = (rnd.nextInt()%100)*0.01f;
      brcMX[i] = (Math.abs(rnd.nextInt()%50)+50)*0.001f;
      brcMY[i] = (Math.abs(rnd.nextInt()%50)+50)*0.001f;
    }
  }

  public final void draw(GLFunc gl) {
    gl.glBegin(GLFunc.GL_LINE_LOOP);
    gl.glVertex3fv(vtxs[0]);
    gl.glVertex3fv(vtxs[1]);
    gl.glVertex3fv(vtxs[2]);
    gl.glVertex3fv(vtxs[3]);
    gl.glEnd();
  }

  public final void setPosition(float x1, float y1, float x2, float y2) {
    vtxs[0][0] = x1; vtxs[0][1] = y1;
    vtxs[1][0] = x2; vtxs[1][1] = y2;
    float wdt = Math.abs(x1-x2)/4, hgt = Math.abs(y1-y2)/4;
    if ( wdt < hgt ) wdt = hgt;
    float cx = (x1+x2)/2, cy = (y1+y2)/2;
    for ( int i=1 ; i>=0 ; i-- ) {
      brcX[i] += brcMX[i];
      if ( brcX[i]<-1 || brcX[i]>1 ) brcMX[i] = -brcMX[i];
      brcY[i] += brcMY[i];
      if ( brcY[i]<-1 || brcY[i]>1 ) brcMY[i] = -brcMY[i];
      vtxs[2+i][0] = cx + brcX[i]*wdt;
      vtxs[2+i][1] = cy + brcY[i]*wdt;
    }
  }
}
