package jp.gr.java_conf.abagames.comraid.stages;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.crafts.*;

public class Stage1 extends StageData {

  public Stage1() {
    CraftGenerator[] cgs = {
      new LtW(), new LtA(), new LtR(), new LtN(), new LtI(), new LtG(),
      new Ls1(), new Dir1(), new Cat1(), new Grp1(),
      new Blt1(), new BltM(), new BltP(), new BltP2(),
    };
    float[][] edSeed = new float[45][10];
    int idx = 0;
    for ( int i=0 ; i<5 ; i++ ) {
      for ( int j=0 ; j<9 ; j++ ) {
        edSeed[idx][0] = 6;

        edSeed[idx][1] = (Comraid.rnd.nextInt()%100)*0.1f;
        edSeed[idx][2] = 0;
        edSeed[idx][3] = 0;
        edSeed[idx][4] = 0;

        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*50;
        idx++;
      }
    }
    addEngageData(edSeed, cgs);
    float[][] es = {
      {7,  -6, 0, 0, 0,  0, 2500, 50, 0, 0},
      {7,   0, 1, 0, 0,  0, 2500, 50, 0, 0},
      {7,   6, 2, 0, 0,  0, 2500, 50, 0, 0},
      {8,  -4, 3, 0, 0,  1, 3000, 100, 1, 400},
      {8,   4, 3, 0, 0,  1, 3000, 100, 1, 400},
      {8,  -5, 2, 0, 0,  2, 3000, 100, 2, 400},
      {8,   5, 2, 0, 0,  2, 3000, 100, 2, 400},
      {8,  -3, 5, 0, 0,  3, 3000, 100, 3, 150},
      {8,   3, 5, 0, 0,  3, 3000, 100, 3, 150},
      {9,  -2, 1, 0, 0,  2, 5000, 50,  0, 100},
      {9,   2, 1, 0, 0,  2, 5000, 50,  0, 100},
      {8,  -8, 0, 0, 0,  4, 4000, 100, 5, 300},
      {8,   4, 2, 0, 0,  4, 4000, 100, 5, 300},
      {8,  -2, 4, 0, 0,  4, 4000, 100, 6, 350},
      {8,   2, 4, 0, 0,  4, 4000, 100, 6, 350},
      {8,  -4, 2, 0, 0,  4, 4000, 100, 7, 400},
      {8,   8, 0, 0, 0,  4, 4000, 100, 7, 400},

      {8,   5, 4, 0, 0,  5, 0, 0, 0, 0},
      {8,   3, 2, 1, 0,  5, 0, 0, 0, 10},
      {8,   2, 1, 2, 0,  5, 0, 0, 0, 20},
      {8,   -5, 4, 2, 0,  5, 0, 0, 0, 100},
      {8,   -3, 2, 1, 0,  5, 0, 0, 0, 110},
      {8,   -2, 1, 0, 0,  5, 0, 0, 0, 120},
      {0,  -9, 0, 0, 0,  5, 2500, 200, 11, 120},
      {1,  -6, 0, 0, 0,  5, 2500, 200, 10, 120},
      {2,  -3, 0, 0, 0,  5, 2500, 200, 9, 120},
      {3,   0, 0, 0, 0,  5, 5000, 100, 0, 120},
      {4,   3, 0, 0, 0,  5, 2500, 200, 9, 120},
      {3,   6, 0, 0, 0,  5, 2500, 200, 10, 120},
      {5,   9, 0, 0, 0,  5, 2500, 200, 11, 120},
    };
    addEngageData(es, cgs);
    float[][] bes = {
      {10,  -8, 1, 0, 0,  4, 20000, 200, 8, 0,
        10, 0,
        0, 0, 0, 0, 0, 0, 0, 0,  4, 0, 0, 0},
      {10,   8, 0, 0, 0,  4, 20000, 200, 8, 0,
        11, 0,
        0, 0, 0, 0, 0, 0, 0, 0,  5, 0, 0, 0},
      {12, -4, 0, 0, 0,  5, 0, 0, 0, 500,
        2, 1,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {12,  4, 0, 0, 0,  5, 0, 0, 0, 500,
        3, 1,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {13,  -6, 0, 0, 0,  5, 0, 0, 0, 500,
        4, 1,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {13,   6, 0, 0, 0,  5, 0, 0, 0, 500,
        5, 1,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
      {11, 0, 0, 0, 0,  5, 0, 0, 0, 500,
        1, 1,
        2, 3, 4, 5, 0, 0, 0, 0, 0, 0, 0, 0},
    };
    addBossEngageData(bes, cgs);
    endEngageData();
  }

  public int getBossEngTime() {
    return 3000;
  }

  public int getStageEndTime() {
    return 3000;
  }

  public String getMessage() {
    return "DIVE INTO CONTINUUM";
  }

  public String getBgmFileName() {
    return "slv001.wav";
  }
}
