package jp.gr.java_conf.abagames.comraid.stages;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.crafts.*;

public class Stage2 extends StageData {

  public Stage2() {
    CraftGenerator[] cgs = {
      new LtW(), new LtA(), new LtR(), new LtN(), new LtI(), new LtG(),
      new Ls3(), new Dir3(), new Tar3(), new Fnd3(), new Rup3(), new Dup3(),
      new PngM(), new PngP1(), new PngP2(),
    };
    float[][] edSeed = new float[70][10];
    int idx = 0;
    for ( int i=0 ; i<7 ; i++ ) {
      for ( int j=0 ; j<10 ; j++ ) {
        edSeed[idx][0] = 6;
        edSeed[idx][1] = (Comraid.rnd.nextInt()%50)*0.1f;
        edSeed[idx][2] = Math.abs(Comraid.rnd.nextInt()%30)*0.1f+2f;
        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*50;
        idx++;
      }
    }
    addEngageData(edSeed, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    float[][] es = new float[40][10];
    idx = 0;
    for ( int i=0 ; i<20 ; i++ ) {
      es[idx][0] = 7;
      es[idx][1] = 1;
      es[idx][2] = 2-((i*5)%11);
      switch ( Math.abs(Comraid.rnd.nextInt()%5) ) {
        case 0:
        case 1:
        case 2:
          es[idx][3] = 0;
          break;
        case 3:
          es[idx][3] = 1;
          break;
        case 4:
          es[idx][3] = 2;
          break;
      }
      es[idx][5] = 0;
      es[idx][6] = 0;
      es[idx][7] = 0;
      es[idx][8] = 0;
      es[idx][9] = i*10+50;
      idx++;
    }
    for ( int i=0 ; i<20 ; i++ ) {
      es[idx][0] = 7;
      es[idx][1] = 0;
      es[idx][2] = ((i*5)%11)-5;
      switch ( Math.abs(Comraid.rnd.nextInt()%5) ) {
        case 0:
        case 1:
        case 2:
          es[idx][3] = 0;
          break;
        case 3:
          es[idx][3] = 1;
          break;
        case 4:
          es[idx][3] = 2;
          break;
      }
      es[idx][5] = 0;
      es[idx][6] = 0;
      es[idx][7] = 0;
      es[idx][8] = 0;
      es[idx][9] = i*10+270;
      idx++;
    }
    addEngageData(es, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    float[][] es2 = {
      {9,  0, 8, 0, 0,  1, 3000, 100, 0, 0},
      {9,  -6, 6, 0, 0,  1, 3000, 100, 0, 30},
      {9,  4, 10, 0, 0,  1, 3000, 100, 0, 60},
      {9,  8, 4, 0, 0,  1, 3000, 100, 0, 90},
      {9,  -2, 8, 0, 0,  1, 3000, 100, 0, 120},
      {9,  -6, 5, 0, 0,  1, 3000, 100, 0, 150},
      {10, -10, 10, 0, 0,  1, 0, 0, 0, 100},
      {9,  -5, 7, 0, 0,  1, 3000, 100, 0, 250},
      {9,  -3, 8, 0, 0,  1, 3000, 100, 0, 280},
      {9,  -1, 9, 0, 0,  1, 3000, 100, 0, 310},
      {9,   1, 9, 0, 0,  1, 3000, 100, 0, 340},
      {9,   3, 8, 0, 0,  1, 3000, 100, 0, 370},
      {9,   5, 7, 0, 0,  1, 3000, 100, 0, 400},
      {10, 10, 10, 1, 0,  1, 0, 0, 0, 350},
      {8,  1, 1, 2, 0,  2, 0, 0, 0, 0},
      {8,  2, 2, 2, 0,  2, 0, 0, 0, 180},
      {10, 1, 6, 0, 0,  3, 5000, 200, 1, 0},
      {10, -1, 6, 1, 0,  3, 5000, 200, 1, 0},
      {10, 3, 9, 0, 0,  3, 5000, 200, 2, 150},
      {10, -3, 9, 1, 0,  3, 5000, 200, 2, 150},
      {9,  -11, -2, 0, 0,  3, 0, 0, 0, 0},
      {9,  11, -6, 0, 0,  3, 0, 0, 0, 60},
      {9,  -11, -1, 0, 0,  3, 0, 0, 0, 120},
      {9,  11, -5, 0, 0,  3, 0, 0, 0, 180},
      {9,  -11, -8, 0, 0,  3, 0, 0, 0, 240},
      {9,  11, -1, 0, 0,  3, 0, 0, 0, 300},
      {8,  2, 3, 2, 0,  4, 0, 0, 0, 0},
      {8,  0, 4, 2, 0,  4, 0, 0, 0, 120},
      {8,  1, 5, 2, 0,  4, 0, 0, 0, 240},
      {11, 5, 8, 0, 0,  5, 2000, 50, 0, 0},
      {11, -5, 8, 0, 0,  5, 2000, 50, 0, 30},
      {11, 2, 8, 0, 0,  5, 2000, 50, 0, 60},
      {11, -1, 8, 0, 0,  5, 2000, 50, 0, 80},
      {11, 9, 8, 0, 0,  5, 2000, 50, 0, 100},
      {11, 6, 8, 0, 0,  5, 2000, 50, 0, 110},
      {11, 3, 8, 0, 0,  5, 2000, 50, 0, 120},
      {11, -3, 8, 1, 0,  5, 2000, 50, 0, 120},
      {11, -8, 8, 1, 0,  5, 2000, 50, 0, 150},
      {11, 2, 8, 1, 0,  5, 2000, 50, 0, 180},
      {11, 5, 8, 1, 0,  5, 2000, 50, 0, 200},
      {11, 9, 8, 1, 0,  5, 2000, 50, 0, 220},
      {11, -1, 8, 1, 0,  5, 2000, 50, 0, 230},
      {11, 1, 8, 1, 0,  5, 2000, 50, 0, 240},
      {10, 0, 0, 0, 0,  5, 0, 0, 0, 350},
      {10, 0, 0, 1, 0,  5, 0, 0, 0, 350},
      {10, -10, 10, 0, 0,  5, 0, 0, 0, 400},
      {10, 10, 10, 1, 0,  5, 0, 0, 0, 400},
      {0,  -9, 0, 0, 0,  6, 3000, 200, 10, 250},
      {1,  -6, 0, 0, 0,  6, 3000, 200, 10, 250},
      {2,  -3, 0, 0, 0,  6, 3000, 200, 12, 250},
      {3,   0, 0, 0, 0,  6, 3000, 200, 12, 250},
      {4,   3, 0, 0, 0,  6, 3000, 200, 12, 250},
      {3,   6, 0, 0, 0,  6, 3000, 200, 11, 250},
      {5,   9, 0, 0, 0,  6, 3000, 200, 11, 250},
    };
    addEngageData(es2, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    // bssID, delayApp
    // mvID,... , mdID,...
    float[][] bes = {
      {12,  0, 0, 0, 0,  7, 0, 0, 0, 0,
       1, 1,
       2, 3, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0},
      {13,  0, 0, 0, 0,  7, 0, 0, 0, 0,
       2, 1,
       0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0},
      {14,  0, 0, 0, 0,  7, 0, 0, 0, 0,
       3, 1,
       0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0},
    };
    addBossEngageData(bes, cgs);
    endEngageData();
  }

  public int getBossEngTime() {
    return 4200;
  }

  public int getStageEndTime() {
    return 2400;
  }

  public String getMessage() {
    return "AN EMPATHY";
  }

  public String getBgmFileName() {
    return "dat002.wav";
  }
}
