package jp.gr.java_conf.abagames.comraid.stages;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.crafts.*;

public class Stage3 extends StageData {

  public Stage3() {
    CraftGenerator[] cgs = {
      new LtW(), new LtA(), new LtR(), new LtN(), new LtI(), new LtG(),
      new Ls2(), new Stt2(), new Mak2(), new Fng2(), new Pwd2(),
      new TrtP(), new TrtM(), new TrtP2(),
    };
    float[][] edSeed = new float[70][10];
    int idx = 0;
    for ( int i=0 ; i<7 ; i++ ) {
      for ( int j=0 ; j<5 ; j++ ) {
        edSeed[idx][0] = 6;
        edSeed[idx][1] = -Math.abs(Comraid.rnd.nextInt()%100)*0.1f;
        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*100+Math.abs(Comraid.rnd.nextInt()%40);
        idx++;
        edSeed[idx][0] = 6;
        edSeed[idx][1] = Math.abs(Comraid.rnd.nextInt()%100)*0.1f;
        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*100+Math.abs(Comraid.rnd.nextInt()%40);
        idx++;
      }
    }
    addEngageData(edSeed, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    float[][] es = {
      {7,  -2, 0, 1, 0,  0, 5000, 150, 0, 150},
      {7,   2, 2, 0, 0,  0, 5000, 150, 0, 200},
      {7,  -3, 2, 0, 0,  0, 5000, 150, 0, 250},
      {7,   1, 0, 1, 0,  0, 5000, 150, 0, 300},
      {7,   0, 0, 2, 0,  0, 5000, 150, 0, 350},
      {7,  -1, 1, 0, 0,  0, 5000, 150, 0, 400},
      {7,   3, 2, 0, 0,  0, 5000, 150, 0, 450},
      {8,   0, 0, 0, 0,  1, 0, 0, 0, 0},
      {7,  -2, 0, 1, 0,  1, 8000, 200, 1, 250},
      {7,   2, 0, 2, 0,  1, 8000, 200, 1, 250},
      {7,  -1, 1, 0, 0,  1, 8000, 200, 2, 350},
      {7,   1, 2, 0, 0,  1, 8800, 200, 2, 350},
      {7,   0, 1, 2, 0,  1, 9000, 600, 0, 400},
      {9,  -1f,0, 0, 0,  2, 4000, 100, 3, 30},
      {9,   2f,0, 0, 0,  2, 4000, 100, 3, 30},
      {9,-2.5f,0, 0, 0,  2, 8000, 200, 4, 200},
      {9, 2.5f,0, 0, 0,  2, 8000, 200, 4, 200},
      {9,-2.5f,0, 0, 0,  2, 6000, 200, 5, 400},
      {9,   1f,0, 0, 0,  2, 6000, 200, 5, 400},
      {10, 0f, 0, 0, 0,  2, 0, 0, 0, 350},
      {10, 0f, 0, 0, 0,  3, 0, 0, 0, 50},
      {10, 9f, 0, 0, 0,  4, 0, 0, 0, 250},
      {10,-9f, 0, 0, 0,  4, 0, 0, 0, 300},
      {10, 0f, 0, 0, 0,  4, 0, 0, 0, 350},
      {7,  -5, 0, 1, 0,  4, 5000, 100, 0, 0},
      {7,  -3, 0, 2, 0,  4, 5000, 100, 0, 40},
      {7,  -1, 0, 1, 0,  4, 5000, 100, 0, 80},
      {7,   1, 0, 2, 0,  4, 5000, 100, 0, 120},
      {7,   3, 0, 1, 0,  4, 5000, 190, 0, 160},
      {7,   5, 0, 2, 0,  4, 5000, 100, 0, 200},
      {10, 6f, 0, 0, 0,  5, 0, 0, 0, 350},
      {10, -6f, 0, 0, 0,  6, 0, 0, 0, 0},
      {0,  -9, 0, 0, 0,  6, 5000, 300, 0, 180},
      {1,  -6, 0, 0, 0,  6, 5000, 200, 0, 180},
      {2,  -3, 0, 0, 0,  6, 5000, 100, 0, 180},
      {3,   0, 0, 0, 0,  6, 5000, 80, 0, 180},
      {4,   3, 0, 0, 0,  6, 5000, 60, 0, 180},
      {3,   6, 0, 0, 0,  6, 5000, 40, 0, 180},
      {5,   9, 0, 0, 0,  6, 5000, 20, 0, 180},
    };
    addEngageData(es, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    // bssID, delayApp
    // mvID,... , mdID,...
    float[][] bes = {
      {11,  0, 3, 0, 0,  5, 10000, 50, 10, 0,
       10, 0,
       0,0,0,0,0,0,0,0, 1,0,0,0},
      {11,  -5, 10, 1, 0,  5, 10000, 50, 10, 0,
       11, 0,
       0,0,0,0,0,0,0,0, 2,0,0,0},
      {11,  5, 10, 2, 0,  5, 10000, 50, 10, 0,
       12, 0,
       0,0,0,0,0,0,0,0, 3,0,0,0},
      {12,  0, 0, 0, 0,  6, 0, 0, 0, 400,
       1, 1,
       2,3,0,0,0,0,0,0, 0,0,0,0},
      {13,  -3, 0, 0, 0,  6, 0, 0, 0, 400,
       2, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {13,  3, 0, 0, 0,  6, 0, 0, 0, 400,
       3, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
    };
    addBossEngageData(bes, cgs);
    endEngageData();
  }

  public int getBossEngTime() {
    return 3600;
  }

  public int getStageEndTime() {
    return 3000;
  }

  public String getMessage() {
    return "FEEL OUTER SPACE";
  }

  public String getBgmFileName() {
    return "gal003.wav";
  }
}
