package jp.gr.java_conf.abagames.comraid.stages;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.crafts.*;

public class Stage4 extends StageData {

  public Stage4() {
    CraftGenerator[] cgs = {
      new LtW(), new LtA(), new LtR(), new LtN(), new LtI(), new LtG(),
      new Zako4(), new Typ4(), new Lnt4(), new Evl4(),
      new Gmpp4(), new Gmpm4(), new Upt4(),
      new XldM(), new XldP1(), new XldP2(), new XldP3(),
    };
    float[][] edSeed = new float[60][10];
    int idx = 0;
    for ( int i=0 ; i<6 ; i++ ) {
      for ( int j=0 ; j<10 ; j++ ) {
        edSeed[idx][0] = 6;
        edSeed[idx][1] = (Comraid.rnd.nextInt()%100)*0.1f;
        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*50;
        idx++;
      }
    }
    addEngageData(edSeed, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    float[][] es = {
      {7, -10, 0, 0, 0,  0, 0, 0, 0,  100},
      {7,  10, 0, 0, 0,  0, 0, 0, 0,  100},
      {7,   0, 0, 0, 0,  0, 0, 0, 0,  120},
      {7,   4, 0, 0, 0,  0, 0, 0, 0,  150},
      {7,  -2, 0, 0, 0,  0, 0, 0, 0,  160},
      {8,  -4, 0, 0, 0,  0, 4000, 100, 0, 250},
      {8,  6, 0, 0, 0,  0, 4000, 100, 0, 350},
      {9,   0, 0, 0, 0,  0, 0, 0, 0, 420},
      {7, -10, 0, 0, 0,  1, 0, 0, 0,  30},
      {7,  10, 0, 0, 0,  1, 0, 0, 0,  30},
      {10,  -5, 9, 0, 0,  1, 10000, 300, 1,  100},
      {10,   5, 9, 0, 0,  1, 10000, 300, 1,  100},
      {11,   0, 5, 0, 0,  1, 0, 0, 0,  120},
      {10,  -5, 0, 0, 0,  1, 10000, 300, 2,  145},
      {10,   5, 0, 0, 0,  1, 10000, 300, 2,  145},
      {7,   0, 0, 0, 0,  2, 0, 0, 0,  30},
      {7,   3, 0, 0, 0,  2, 0, 0, 0,  60},
      {7,   6, 0, 0, 0,  2, 0, 0, 0,  90},
      {12,   0, 0, 0, 0,  2, 0, 0, 0,  180},
      {7,   -1, 0, 0, 0,  2, 0, 0, 0,  270},
      {7,   -4, 0, 0, 0,  2, 0, 0, 0,  300},
      {7,   -7, 0, 0, 0,  2, 0, 0, 0,  330},
      {12,   5, 0, 0, 0,  2, 0, 0, 0,  400},
      {12,  -5, 0, 0, 0,  2, 0, 0, 0,  420},
      {10, -11, 8, 0, 0,  3, 10000, 300, 3,  0},
      {10,  -1, 8, 0, 0,  3, 10000, 300, 3,  0},
      {11,  -6, 4, 0, 0,  3, 0, 0, 0,  20},
      {10, -11, -1, 0, 0,  3, 10000, 300, 4,  45},
      {10,  -1, -1, 0, 0,  3, 10000, 300, 4,  45},
      {10,   1, 10, 0, 0,  3, 10000, 300, 5,  200},
      {10,  11, 10, 0, 0,  3, 10000, 300, 5,  200},
      {11,   6, 6, 0, 0,  3, 0, 0, 0,  220},
      {10,   1, 1, 0, 0,  3, 10000, 300, 6,  245},
      {10,  11, 1, 0, 0,  3, 10000, 300, 6,  245},
      {7,   -2, 0, 0, 0,  4, 0, 0, 0,  200},
      {12,  -7, 0, 0, 0,  4, 0, 0, 0,  220},
      {7,    8, 0, 0, 0,  4, 0, 0, 0,  240},
      {7,    4, 0, 0, 0,  4, 0, 0, 0,  280},
      {12,   1, 0, 0, 0,  4, 0, 0, 0,  300},
      {7,    6, 0, 0, 0,  4, 0, 0, 0,  320},
      {7,   -3, 0, 0, 0,  4, 0, 0, 0,  360},
      {8,  -9, 0, 0, 0,  5, 0, 0, 0, 100},
      {8,  -3, 0, 0, 0,  5, 0, 0, 0, 100},
      {8,   3, 0, 0, 0,  5, 0, 0, 0, 100},
      {8,   9, 0, 0, 0,  5, 0, 0, 0, 100},
      {8,  -9, 0, 0, 0,  5, 0, 0, 0, 400},
      {8,  -3, 0, 0, 0,  5, 0, 0, 0, 400},
      {8,   3, 0, 0, 0,  5, 0, 0, 0, 400},
      {8,   9, 0, 0, 0,  5, 0, 0, 0, 400},
      {9,   -5, 0, 0, 0,  6, 0, 0, 0, 30},
      {9,   5, 0, 0, 0,  6, 0, 0, 0, 90},
      {0,  -9, 0, 0, 0,  6, 5000, 100, 7, 180},
      {1,  -6, 0, 0, 0,  6, 5000, 100, 7, 180},
      {2,  -3, 0, 0, 0,  6, 5000, 100, 7, 180},
      {3,   0, 0, 0, 0,  6, 5000, 100, 7, 180},
      {4,   3, 0, 0, 0,  6, 5000, 100, 7, 180},
      {3,   6, 0, 0, 0,  6, 5000, 100, 7, 180},
      {5,   9, 0, 0, 0,  6, 5000, 100, 7, 180},
    };
    addEngageData(es, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    // bssID, delayApp
    // mvID,... , mdID,...
    float[][] bes = {
      {13,  0, 0, 0, 0,  4, 0, 0, 0, 0,
       1, 0,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {14, -6, 0, 0, 0,  6, 30000, 300, 10, 500,
       2, 1,
       0,0,0,0,0,0,0,0, 4,0,0,0},
      {14,  6, 0, 0, 0,  6, 30000, 300, 10, 500,
       3, 1,
       0,0,0,0,0,0,0,0, 5,0,0,0},
      {15, -8, 0, 0, 0,  6, 0, 0, 0, 530,
       4, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {16, 8, 0, 0, 0,  6, 0, 0, 0, 530,
       5, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {14, -10, 4, 0, 0,  6, 30000, 300, 11, 470,
       6, 1,
       0,0,0,0,0,0,0,0, 1,0,0,0},
      {14,  10, 4, 0, 0,  6, 30000, 300, 11, 470,
       7, 1,
       0,0,0,0,0,0,0,0, 1,0,0,0},
    };
    addBossEngageData(bes, cgs);
    endEngageData();
  }

  public int getBossEngTime() {
    return 3600;
  }

  public int getStageEndTime() {
    return 2400;
  }

  public String getMessage() {
    return "COME OUT OF A TRANCE";
  }

  public String getBgmFileName() {
    return "trt004.wav";
  }
}
