package jp.gr.java_conf.abagames.comraid.stages;

import jp.gr.java_conf.abagames.comraid.*;
import jp.gr.java_conf.abagames.comraid.crafts.*;

public class Stage5 extends StageData {

  public Stage5() {
    CraftGenerator[] cgs = {
      new LtW(), new LtA(), new LtR(), new LtN(), new LtI(), new LtG(),
      new Gcc5(), new Zip5(), new Nst5(), new Kll5(),
      new Uue5(), new Nce5(), new Dff5(),
      new OclM(), new OclP1(), new OclP2(), new OclP3(),
    };
    float[][] edSeed = new float[24][10];
    int idx = 0;
    for ( int i=0 ; i<3 ; i++ ) {
      for ( int j=0 ; j<8 ; j++ ) {
        edSeed[idx][0] = 6;
        edSeed[idx][1] = (Comraid.rnd.nextInt()%100)*0.1f;
        edSeed[idx][2] = Math.abs(Comraid.rnd.nextInt()%60)*0.1f+4;
        edSeed[idx][5] = i;
        edSeed[idx][6] = 0;
        edSeed[idx][7] = 0;
        edSeed[idx][8] = 0;
        edSeed[idx][9] = j*60;
        idx++;
      }
    }
    addEngageData(edSeed, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    float[][] es = {
      {7,  -9, 0, 1, 0,  0, 5000, 100, 1, 50},
      {7,   9, 0, 2, 0,  0, 5000, 100, 1, 50},
      {8,   0, 0, 0, 0,  0, 0, 0, 0, 50},
      {8,   1, 0, 0, 0,  0, 0, 0, 0, 70},
      {8,   2, 0, 0, 0,  0, 0, 0, 0, 90},
      {7,  -7, 1, 0, 0,  0, 5000, 100, 2, 100},
      {7,   7, 2, 0, 0,  0, 5000, 100, 2, 100},
      {7,  -4, 0, 1, 0,  0, 5000, 100, 3, 150},
      {7,   4, 0, 2, 0,  0, 5000, 100, 3, 150},
      {7,  -4, 2, 0, 0,  0, 5000, 100, 4, 250},
      {7,   8, 1, 0, 0,  0, 5000, 100, 4, 250},
      {7,  -8, 0, 2, 0,  0, 5000, 100, 5, 300},
      {7,   4, 0, 1, 0,  0, 5000, 100, 5, 300},
      {8,   0, 0, 0, 0,  0, 0, 0, 0, 300},
      {8,   1, 0, 0, 0,  0, 0, 0, 0, 320},
      {8,   2, 0, 0, 0,  0, 0, 0, 0, 340},
      {7,  -9, 2, 0, 0,  0, 5000, 100, 6, 350},
      {7,   9, 1, 0, 0,  0, 5000, 100, 6, 350},
      {9,   0, 0, 0, 0,  3, 0, 0, 0, 0},
      {10, -10, 10, 0, 0,  3, 0, 0, 0, 30},
      {10,  10, 10, 0, 0,  3, 0, 0, 0, 30},
      {10, -10, 5, 90, 0,  3, 0, 0, 0, 90},
      {10,  10, 5, 270, 0,  3, 0, 0, 0, 90},
      {10, -8, 8, 0, 0,  3, 0, 0, 0, 150},
      {10, 10, 2, 270, 0,  3, 0, 0, 0, 180},
      {10, -10, 4, 90, 0,  3, 0, 0, 0, 210},
      {10, 8, 8, 0, 0,  3, 0, 0, 0, 240},
      {10, 10, 0, 270, 0,  3, 0, 0, 0, 270},
      {10, -10, 0, 90, 0,  3, 0, 0, 0, 300},
      {10, -10, 5, 0, 0,  3, 0, 0, 0, 330},
      {10, 10, 5, 0, 0,  3, 0, 0, 0, 360},
      {10, -10, 2, 90, 0,  3, 0, 0, 0, 390},
      {10, 10, 0, 270, 0,  3, 0, 0, 0, 420},

      {11,  0, 9, 2, 0,  5, 0, 0, 0, 100},
      {11,  7.5f, 4.5f, 2, 0,  5, 0, 0, 0, 100},
      {11,  9, 0, 2, 0,  5, 0, 0, 0, 100},
      {11,  7.5f, -4.5f, 2, 0,  5, 0, 0, 0, 100},
      {11,  6, -6, 2, 0,  5, 0, 0, 0, 100},
      {11,  4.5f, -7.5f, 2, 0,  5, 0, 0, 0, 100},
      {11,  0, -9, 2, 0,  5, 0, 0, 0, 100},
      {11,  -4.5f, -7.5f, 2, 0,  5, 0, 0, 0, 100},
      {11,  -7.5f, 4.5f, 2, 0,  5, 0, 0, 0, 100},
      {11,  -6, 6, 2, 0,  5, 0, 0, 0, 100},
      {11,  -4.5f, 7.5f, 2, 0,  5, 0, 0, 0, 100},

      {11,  0, 9, 1, 0,  5, 0, 0, 0, 200},
      {11,  7.5f, 4.5f, 1, 0,  5, 0, 0, 0, 200},
      {11,  9, 0, 1, 0,  5, 0, 0, 0, 200},
      {11,  7.5f, -4.5f, 1, 0,  5, 0, 0, 0, 200},
      {11,  6, -6, 1, 0,  5, 0, 0, 0, 200},
      {11,  -6, -6, 1, 0,  5, 0, 0, 0, 200},
      {11,  -7.5f, -4.5f, 1, 0,  5, 0, 0, 0, 200},
      {11,  -9, 0, 1, 0,  5, 0, 0, 0, 200},
      {11,  -7.5f, 4.5f, 1, 0,  5, 0, 0, 0, 200},
      {11,  -6, 6, 1, 0,  5, 0, 0, 0, 200},
      {11,  -4.5f, 7.5f, 1, 0,  5, 0, 0, 0, 200},

      {11,  0, 9, 0, 0,  5, 0, 0, 0, 300},
      {11,  4.5f, 7.5f, 0, 0,  5, 0, 0, 0, 300},
      {11,  6, 6, 0, 0,  5, 0, 0, 0, 300},
      {11,  7.5f, 4.5f, 0, 0,  5, 0, 0, 0, 300},
      {11,  9, 0, 0, 0,  5, 0, 0, 0, 300},
      {11,  4.5f, -7.5f, 0, 0,  5, 0, 0, 0, 300},
      {11,  0, -9, 0, 0,  5, 0, 0, 0, 300},
      {11,  -4.5f, -7.5f, 0, 0,  5, 0, 0, 0, 300},
      {11,  -6, -6, 0, 0,  5, 0, 0, 0, 300},
      {11,  -7.5f, -4.5f, 0, 0,  5, 0, 0, 0, 300},
      {11,  -9, 0, 0, 0,  5, 0, 0, 0, 300},

      {11,  0, 9, 1, 0,  5, 0, 0, 0, 400},
      {11,  4.5f, 7.5f, 1, 0,  5, 0, 0, 0, 400},
      {11,  6, 6, 1, 0,  5, 0, 0, 0, 400},
      {11,  7.5f, 4.5f, 1, 0,  5, 0, 0, 0, 400},
      {11,  9, 0, 1, 0,  5, 0, 0, 0, 400},
      {11,  7.5f, -4.5f, 1, 0,  5, 0, 0, 0, 400},
      {11,  0, -9, 1, 0,  5, 0, 0, 0, 400},
      {11,  -4.5f, -7.5f, 1, 0,  5, 0, 0, 0, 400},
      {11,  -6, -6, 1, 0,  5, 0, 0, 0, 400},
      {11,  -7.5f, -4.5f, 1, 0,  5, 0, 0, 0, 400},
      {11,  -4.5f, 7.5f, 1, 0,  5, 0, 0, 0, 400},

      {11,  6, 6, 2, 0,  5, 0, 0, 0, 500},
      {11,  7.5f, 4.5f, 2, 0,  5, 0, 0, 0, 500},
      {11,  9, 0, 2, 0,  5, 0, 0, 0, 500},
      {11,  7.5f, -4.5f, 2, 0,  5, 0, 0, 0, 500},
      {11,  6, -6, 2, 0,  5, 0, 0, 0, 500},
      {11,  4.5f, -7.5f, 2, 0,  5, 0, 0, 0, 500},
      {11,  0, -9, 2, 0,  5, 0, 0, 0, 500},
      {11,  -7.5f, -4.5f, 2, 0,  5, 0, 0, 0, 500},
      {11,  -9, 0, 2, 0,  5, 0, 0, 0, 500},
      {11,  -7.5f, 4.5f, 2, 0,  5, 0, 0, 0, 500},
      {11,  -6, 6, 2, 0,  5, 0, 0, 0, 500},

      {12,  0, 10, 0, 0,  6, 0, 0, 0, 0},
      {12, -10, -6, 90, 1,  6, 0, 0, 0, 0},
      {12,  10, -6, 270, 2,  6, 0, 0, 0, 0},

      {0,  -9, 0, 0, 0,  7, 5000, 50, 7, 0},
      {1,  -6, 0, 0, 0,  7, 8000, 50, 8, 0},
      {2,  -3, 0, 0, 0,  7, 5000, 50, 7, 0},
      {3,   0, 0, 0, 0,  7, 8000, 50, 8, 0},
      {4,   3, 0, 0, 0,  7, 5000, 50, 9, 0},
      {3,   6, 0, 0, 0,  7, 8000, 50, 8, 0},
      {5,   9, 0, 0, 0,  7, 5000, 50, 9, 0},
    };
    addEngageData(es, cgs);
    // type, arg1,arg2,arg3,arg4, lyrOfs, stBns, dcrScr, dattID, time
    // bssID, delayApp
    // mvID,... , mdID,...
    float[][] bes = {
      {13,  0, 0, 0, 0,  7, 0, 0, 0, 200,
       1, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {14,  0, 0, 0, 0,  7, 0, 0, 0, 200,
       2, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {15,  0, 0, 0, 0,  7, 0, 0, 0, 200,
       3, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
      {16,  0, 0, 0, 0,  7, 0, 0, 0, 200,
       4, 1,
       0,0,0,0,0,0,0,0, 0,0,0,0},
    };
    addBossEngageData(bes, cgs);
    endEngageData();
  }

  public int getBossEngTime() {
    return 4200;
  }

  public int getStageEndTime() {
    return 2400;
  }

  public String getMessage() {
    return "THERE IS NOTHING FOR IT";
  }

  public String getBgmFileName() {
    return "mgm005.wav";
  }
}
