package jp.gr.java_conf.abagames.util.gl4j;

import jp.gr.java_conf.abagames.comraid.IInit;
import gl4java.*;
import gl4java.awt.*;
import java.awt.Graphics;

/**
  OpenGL Scene Manager
  */
public class Scene extends GLCanvas {
  public GLFunc glFunc;
  private IInit initInst;

  public Scene(int width, int height, IInit initInst) {
    super(width, height);
    glFunc = gl;
    this.initInst = initInst;
  }

  public void display() {
    try {
      clear();
      initInst.display();
      swap();
    } catch ( Exception e ) {
      return;
    }
  }

  public void init() {
		gl.glClearColor( 0f, 0f, 0f, 0f );
		gl.glFrontFace( GL_CW );

    gl.glDisable(GL_LIGHTING);
    gl.glDisable(GL_LIGHT0);
    gl.glDisable(GL_DITHER);

		gl.glDisable(GL_DEPTH_TEST);
		gl.glDisable(GL_CULL_FACE);
		gl.glDisable(GL_ALPHA_TEST);
		gl.glDisable(GL_TEXTURE);

		int width  = cvsGetWidth();
		int height = cvsGetHeight();

		gl.glViewport( 0, 0, width, height );

	  /* Setup the view of the cube. */
	  gl.glMatrixMode(GL_PROJECTION);
	  gl.glLoadIdentity();
	  glu.gluPerspective( /* field of view in degree */ 90.0,
	    /* aspect ratio */ width/height,
	    /* Z near */ 1.0, /* Z far */ 100.0);
	  gl.glMatrixMode(GL_MODELVIEW);
	  gl.glLoadIdentity();
    glj.gljCheckGL();

    initInst.init();
  }

  /**
    Set the viewpoint
    */
  public void setViewpoint(
   double ex, double ey, double ez, double cx, double cy, double cz) {
    glu.gluLookAt(ex, ey, ez, cx, cy, cz, 0, 1.0, 0);
  }

  public void clear() throws SceneStartException {
		if( glj.gljMakeCurrent(true) == false ) {
			throw new SceneStartException();
		}
    gl.glClear(GL_COLOR_BUFFER_BIT);
  }

  public void makeCurrent() throws SceneStartException {
		if( glj.gljMakeCurrent(true) == false ) {
			throw new SceneStartException();
		}
  }

  public void swap() {
    glj.gljSwap();
    glj.gljCheckGL();
    glj.gljFree();
  }

  public void destroy() {
    cvsDispose();
  }
}

