package jp.gr.java_conf.abagames.util.gl4j;

import jp.gr.java_conf.abagames.comraid.*;

/**
  Scene display thread
  */
public class SceneDspThread implements Runnable {
  private IInit initInst;
  private Scene scene;
  private boolean loopf = true;

  synchronized private void waitFrame() {
    try {
      wait();
    } catch ( InterruptedException e ) {}
  }

  synchronized final public void notifyFrame() {
    notifyAll();
  }

  public void run() {
    while ( loopf ) {
      waitFrame();
      try {
        scene.clear();
        initInst.display();
        scene.swap();
      } catch ( SceneStartException e ) {}
    }
  }

  public void terminate() {
    loopf = false;
  }

  public SceneDspThread(IInit initInst, Scene scene) {
    this.initInst = initInst;
    this.scene = scene;
    Thread thread = new Thread(this);
    thread.start();
  }
}